package ${basePackage}.module.system.mpr;

import org.apache.ibatis.annotations.Mapper;
import org.apache.ibatis.annotations.Param;
import ${basePackage}.frame.auth.Token;
import ${basePackage}.module.system.ent.File;
import ${basePackage}.module.system.req.FileDeleteRequest;
import ${basePackage}.module.system.req.FileFindRequest;
import ${basePackage}.module.system.req.FileGetRequest;

import java.util.List;

/**
 * FILE - 文件
 *
 * @author author
 * @date 2019-11-29
 */
@Mapper
public interface FileMapper {

    /**
     * 插入
     *
     * @param request 请求对象
     * @param token   令牌
     * @return 返回数量
     */
    long insert(@Param("request") File request, @Param("token") Token token);

    /**
    * 批量插入
    *
    * @param request 请求对象
    * @param token   令牌
    * @return 返回数量
    */
    long insertBatch(@Param("list") List<File> request, @Param("token") Token token);

    /**
     * 逻辑删除
     *
     * @param request 请求对象
     * @param token   令牌
     * @return 返回数量
     */
    long delete(@Param("request") FileDeleteRequest request, @Param("token") Token token);

    /**
     * 查询
     *
     * @param request 请求对象
     * @param token   令牌
     * @return 返回对象
     */
    List<File> find(@Param("request") FileFindRequest request, @Param("token") Token token);

    /**
     * 获得对象
     *
     * @param request 请求对象
     * @param token   令牌
     * @return 返回对象
     */
    File get(@Param("request") FileGetRequest request, @Param("token") Token token);
}
