package ${basePackage}.module.system.mpr;

import org.apache.ibatis.annotations.Mapper;
import org.apache.ibatis.annotations.Param;
import ${basePackage}.frame.auth.Token;
import ${basePackage}.module.system.ent.Res;
import ${basePackage}.module.system.req.ResDeleteRequest;
import ${basePackage}.module.system.req.ResFindRequest;
import ${basePackage}.module.system.req.ResGetRequest;
import ${basePackage}.module.system.req.ResLoadRequest;
import ${basePackage}.module.system.req.ResUpdateRequest;

import java.util.List;

/**
 * RES - 资源
 *
 * @author wangbing
 * @date 2020-01-05
 */
@Mapper
public interface ResMapper {

    /**
     * 插入
     *
     * @param request 请求对象
     * @param token   令牌
     * @return 返回数量
     */
    long insert(@Param("request") Res request, @Param("token") Token token);

    /**
     * 批量插入
     *
     * @param request 请求对象
     * @param token   令牌
     * @return 返回数量
     */
    long insertBatch(@Param("list") List<Res> request, @Param("token") Token token);

    /**
     * 逻辑删除
     *
     * @param request 请求对象
     * @param token   令牌
     * @return 返回数量
     */
    long delete(@Param("request") ResDeleteRequest request, @Param("token") Token token);

    /**
     * 更新
     *
     * @param request 请求对象
     * @param token   令牌
     * @return 返回数量
     */
    long update(@Param("request") ResUpdateRequest request, @Param("token") Token token);

    /**
     * 查询
     *
     * @param request 请求对象
     * @param token   令牌
     * @return 返回对象
     */
    List<Res> find(@Param("request") ResFindRequest request, @Param("token") Token token);

    /**
     * 加载
     *
     * @param request 请求对象
     * @param token   令牌
     * @return 返回对象
     */
    List<Res> load(@Param("request") ResLoadRequest request, @Param("token") Token token);

    /**
     * 获得对象
     *
     * @param request 请求对象
     * @param token   令牌
     * @return 返回对象
     */
    Res get(@Param("request") ResGetRequest request, @Param("token") Token token);
}
