package ${basePackage}.module.system.mpr;

import org.apache.ibatis.annotations.Mapper;
import org.apache.ibatis.annotations.Param;
import ${basePackage}.frame.auth.Token;
import ${basePackage}.module.system.ent.UserRole;
import ${basePackage}.module.system.req.UserRoleDeleteRequest;
import ${basePackage}.module.system.req.UserRoleFindRequest;
import ${basePackage}.module.system.req.UserRoleGetRequest;
import ${basePackage}.module.system.req.UserRoleUpdateRequest;

import java.util.List;

/**
 * USER_ROLE - 用户角色授权
 *
 * @author wangbing
 * @date 2019-12-20
 */
@Mapper
public interface UserRoleMapper {

    /**
     * 插入
     *
     * @param request 请求对象
     * @param token   令牌
     * @return 返回数量
     */
    long insert(@Param("request") UserRole request, @Param("token") Token token);

    /**
    * 批量插入
    *
    * @param request 请求对象
    * @param token   令牌
    * @return 返回数量
    */
    long insertBatch(@Param("list") List<UserRole> request, @Param("token") Token token);

    /**
     * 逻辑删除
     *
     * @param request 请求对象
     * @param token   令牌
     * @return 返回数量
     */
    long delete(@Param("request") UserRoleDeleteRequest request, @Param("token") Token token);

    /**
     * 更新
     *
     * @param request 请求对象
     * @param token   令牌
     * @return 返回数量
     */
    long update(@Param("request") UserRoleUpdateRequest request, @Param("token") Token token);

    /**
     * 查询
     *
     * @param request 请求对象
     * @param token   令牌
     * @return 返回对象
     */
    List<UserRole> find(@Param("request") UserRoleFindRequest request, @Param("token") Token token);

    /**
     * 获得对象
     *
     * @param request 请求对象
     * @param token   令牌
     * @return 返回对象
     */
    UserRole get(@Param("request") UserRoleGetRequest request, @Param("token") Token token);
}
