<#if dataBase == 'Oracle'>
-- ----------------------------
-- Table structure for ${table.tableName} - ${table.tableComment?default("")}
-- Target   : Oracle
-- Author   : ${author}
-- Date:    : ${date?string("yyyy-MM-dd")}
-- ----------------------------
CREATE TABLE "${module.modulePrefix}${table.tableName}" (
<#list table.fields as field>
    ${dBmapper.getFieldSql(field)}<#if field_has_next>,</#if>
</#list>
);

COMMENT ON TABLE "${module.modulePrefix?default("")}${table.tableName}" is '${table.tableComment}';
<#list table.fields as field>
COMMENT ON COLUMN "${module.modulePrefix?default("")}${table.tableName}"."${field.fieldName?default("")}" is '${field.fieldComment?default("")}';
</#list>
</#if>
<#if dataBase == 'MySQL'>
-- ----------------------------
-- Table structure for ${table.tableName} - ${table.tableComment?default("")}
-- Target   : MySQL
-- Author   : ${author}
-- Date:    : ${date?string("yyyy-MM-dd")}
-- ----------------------------
CREATE TABLE `${module.modulePrefix?default("")}${table.tableName}` (
    <#list table.fields as field>
        ${dBmapper.getFieldSql(field)}<#if field_has_next||table.sys>,</#if>
    </#list>
<#if table.sys>
PRIMARY KEY (`ID`)
</#if>
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='${table.tableComment?default("")}';
</#if>
<#if dataBase == 'SQLite'>
-- ----------------------------
-- Table structure for ${table.tableName} - ${table.tableComment?default("")}
-- Target   : SQLite
-- Author   : ${author}
-- Date:    : ${date?string("yyyy-MM-dd")}
-- ----------------------------
CREATE TABLE IF NOT EXISTS ${module.modulePrefix?default("")}${table.tableName} (
    <#list table.fields as field>
    ${dBmapper.getFieldSql(field)}<#if field_has_next>,</#if>
    </#list>
);
</#if>