<div id="index" v-cloak>
    <div id="loadingBar" v-if="barPercent > 0">
        <el-progress
                :percentage="barPercent"
                :stroke-width="2"
                :show-text="false"
                :status="barStatus"
                stroke-linecap="round"></el-progress>
    </div>

    <div id="aside" :style="{width:(prop.coll?'64px':'200px')}">
        <el-menu
                @open="handleOpen"
                @close="handleClose"
                @select="handleSelect"
                :default-active="prop.defaultActive"
                :unique-opened="prop.open"
                :collapse="prop.coll"
                :collapse-transition="prop.tran"
                background-color="#252a2f"
                text-color="#d6d6d6"
                active-text-color="#ffd04b">
<#if sysMD>
            ${print('<#if token.hasRes("DEV")>')}
            <el-submenu index="${tool.uuid()}" >
                <template slot="title">
                    <i class="el-icon-help"></i>
                    <span slot="title">开发设置</span>
                </template>
                <el-menu-item index="${tool.uuid()}" @click="addTab({title: '资源管理', name: 'res', url: '${r'${context}'}/system/res.htm'})">资源管理</el-menu-item>
                <el-menu-item index="${tool.uuid()}" @click="addTab({title: '错误日志', name: 'LOG_ERR', url: '${r'${context}'}/system/logErr.htm'})">错误日志</el-menu-item>
                <el-menu-item index="${tool.uuid()}" @click="addTab({title: '计划调度', name: 'schedule', url: '${r'${context}'}/system/schedule.htm'})">计划调度</el-menu-item>
            </el-submenu>
            ${print('</#if>')}
            ${print('<#if token.hasRes("SYS")>')}
            <el-submenu index="${tool.uuid()}" >
                <template slot="title">
                    <i class="el-icon-setting"></i>
                    <span slot="title">基本设置</span>
                </template>
                <el-menu-item index="${tool.uuid()}" @click="addTab({title: '字典管理', name: 'dict', url: '${r'${context}'}/system/dict.htm'})">字典管理</el-menu-item>
                <el-menu-item index="${tool.uuid()}" @click="addTab({title: '角色管理', name: 'role', url: '${r'${context}'}/system/role.htm'})">角色管理</el-menu-item>
                <el-menu-item index="${tool.uuid()}" @click="addTab({title: '部门管理', name: 'dept', url: '${r'${context}'}/system/dept.htm'})">部门管理</el-menu-item>
                <el-menu-item index="${tool.uuid()}" @click="addTab({title: '用户管理', name: 'user', url: '${r'${context}'}/system/user.htm'})">用户管理</el-menu-item>
                <el-menu-item index="${tool.uuid()}" @click="addTab({title: '文件管理', name: 'file', url: '${r'${context}'}/system/file.htm'})">文件管理</el-menu-item>
                <el-menu-item index="${tool.uuid()}" @click="addTab({title: '登录管理', name: 'tokens', url: '${r'${context}'}/system/tokens.htm'})">登录管理</el-menu-item>
            </el-submenu>
            ${print('</#if>')}
</#if>
<#list modules as item>
<#if item.hasHtml()>
            ${print('<#if token.hasRes("WEB_')}${item.moduleName?upper_case}${print('")>')}
            <el-submenu index="${tool.uuid()}">
                <template slot="title">
                    <i class="el-icon-document-copy"></i>
                    <span slot="title">${item.moduleComment}</span>
                </template>
                <#list item.tables as table>
                <#if table.getHtml()>
                <el-menu-item index="${tool.uuid()}" @click="addTab({title: '${table.tableComment}', name: '${table.tableName}', url: '${r"${context}"}/${item.moduleName}/${table.getFName()}.htm'})">${table.tableComment}</el-menu-item>
                </#if>
                </#list>
            </el-submenu>
            ${print('</#if>')}
</#if>
</#list>
        </el-menu>
    </div>

    <div id="main" :style="{marginLeft:(prop.coll?'64px':'200px')}">
        <div id="head">
            <div class="collapseSwitch" @click="collapseSwitch">
                <a :class="prop.coll?'reversal':''"><i class="el-icon-s-fold"></i></a>
            </div>

            <el-link :underline="false" @click="onHome" icon="el-icon-s-home">首页</el-link>

            <div class="menu">
                <ul>
                    <li>
                        <el-dropdown>
                            <el-link :underline="false" @click="onHome" icon="el-icon-user-solid">${r'${token.userName?default("登录信息")}'}</el-link>

                            <el-dropdown-menu slot="dropdown" @command="onCommand">
                                <el-dropdown-item>个人信息</el-dropdown-item>
                                <el-dropdown-item>修改密码</el-dropdown-item>
                                <el-dropdown-item :command="'logout'">退出登录</el-dropdown-item>
                            </el-dropdown-menu>
                        </el-dropdown>
                    </li>
                    <li>
                        <el-link :underline="false" @click="onHome" icon="el-icon-message-solid"><span
                                style="line-height: 20px;"><el-badge is-dot class="item">消息</el-badge></span></el-link>
                    </li>
                    <li>
                        <el-link :underline="false" icon="el-icon-full-screen" @click="switchFullScreen">全屏</el-link>
                    </li>
                    <li>
                        <el-dropdown @command="onCommand">
                            <el-link :underline="false" icon="el-icon-switch-button"></el-link>

                            <el-dropdown-menu slot="dropdown">
                                <el-dropdown-item :command="'logout'">注销</el-dropdown-item>
                            </el-dropdown-menu>
                        </el-dropdown>
                    </li>
                </ul>
            </div>
        </div>
        <div id="content">
            <el-tabs v-model="activeTabName" type="border-card" closable @tab-remove="removeTab">
                <el-tab-pane
                        v-for="(item, index) in tabs"
                        :lazy="true"
                        :key="item.name"
                        :label="item.title"
                        :name="item.name">
                    <iframe :src="item.url" style="width: 100%;height: 100%;border: 0;"></iframe>
                </el-tab-pane>
            </el-tabs>
        </div>
    </div>
</div>
<style>
    * {
        box-sizing: border-box;
        margin: 0;
        padding: 0;
    }

    html, body, #index {
        width: 100%;
        height: 100%;
        overflow: hidden;
    }

    a:active, a:hover {
        opacity: 0.7;
        outline: 0;
        text-decoration: none
        cursor: pointer;
    }

    #loadingBar {
        position: fixed;
        z-index: 99;
        top: 0;
        left: 0;
        right: 0;
    }

    #loadingBar div[role=progressbar] {
        position: fixed;
        top: 0;
        left: 0;
        right: 0;
        z-index: 99;
    }

    #loadingBar div[role=progressbar] .el-progress-bar__outer{
        background-color: transparent;
    }

    #aside {
        overflow: hidden;
        height: 100%;
        position: fixed;
        left: 0;
        top: 0;
        bottom: 0;
        transition: all .5s;
        background: #252a2f;
    }

    #aside ul[role=menubar] {
        border-right: solid 0 #e6e6e6;
    }

    .el-submenu__title{
        height: 40px!important;
        line-height: 40px!important;
    }
    .el-menu-item {
        height: 40px!important;
        line-height: 40px!important;
    }
    .el-menu--popup-right-start{
        padding: 0px;
    }

    #main {
        height: 100%;
        margin-left: 200px;
        transition: all .5s;
    }

    #head {
        width: 100%;
        height: 40px;
        line-height: 40px;
        overflow: hidden;
        background: #252a2f;
    }

    #head .collapseSwitch {
        display: inline-block;
        height: 40px;
        width: 40px;
        text-align: center;
        font-size: 24px;
        border-left: 1px solid #424242;
        border-right: 1px solid #424242;
    }

    #head .collapseSwitch a {
        display: inline-block;
        transition: all .5s;
    }

    #head .collapseSwitch a.reversal {
        transform: rotate(-180deg);
    }

    #head a {
        color: #d6d6d6;
        vertical-align: top;
    }

    #head a:hover {
        color: #409EFF;
        opacity: 1;
    }

    #head .collapseSwitch:hover {
        background: #3b4146;
    }

    #head .menu {
        display: inline-block;
        float: right;
    }

    #head .menu ul {
        display: inline-block;
    }

    #head .menu ul li {
        display: inline-block;
        vertical-align: top;
    }

    #head .menu ul li a {
        display: inline-block;
        text-align: center;
        position: relative;
        margin: 0 10px;
        height: 40px;
        vertical-align: top;
    }

    #head .menu ul li a:after {
        content: "";
        display: inline-block;
        background: #409EFF;
        width: 0;
        height: 2px;
        position: absolute;
        bottom: 2px;
        left: 50%;
        transition: all 0.3s;
    }

    #head .menu ul li a:hover:after {
        width: 100%;
        left: 0;
    }

    #content,#content .el-tabs__content  {
        padding: 0;
        height: calc(100% - 40px);
    }

    #content > div,#content .el-tab-pane  {
        padding: 0;
        height: 100%;
    }

    #content div[role=tab]{
        padding: 0 10px;
    }
</style>
<script>
    window.index = new Vue({
        el: "#index",
        data: {
            tabs: [],//所有Tabs
            activeTabName: '',
            barStatus:null,
            barPercent: 0,
            barInterval: null,
            prop: {
                open: ${r"<#if prop.open>true<#else>false</#if>"},
                coll: ${r"<#if prop.coll>true<#else>false</#if>"},
                tran: ${r"<#if prop.tran>true<#else>false</#if>"},
                full: ${r"<#if prop.full>true<#else>false</#if>"}
            }
        },
        methods: {
            onHome: function () {
                this.addTab({
                    title: '首页',
                    name: 'home',
                    url: '${r"${context}"}/home.htm'
                })
            },
            barStart: function () {
                clearInterval(this.barInterval);
                this.barPercent = 10;
                this.barInterval = setInterval(function () {
                    this.barPercent = this.barPercent + (90 - this.barPercent) * 0.01;
                }.bind(this), 100)
            },
            barFinish: function () {
                clearInterval(this.barInterval);
                this.barPercent = 100;
                setTimeout(function () {
                    this.barPercent = 0;
                }.bind(this), 1000);
            },
            barError: function () {
                clearInterval(this.barInterval);
                this.barPercent = 100;
                this.barStatus = 'exception'
                setTimeout(function () {
                    this.barPercent = 0;
                    this.barStatus = null;
                }.bind(this), 1000);
            },
            collapseSwitch: function () {
                this.prop.coll = !this.prop.coll;
            },
            handleOpen: function () {

            },
            handleClose: function () {

            },
            handleSelect: function (index) {

            },
            addTab: function (tab) {
                //查找是否存在该tab
                var tempTabs = this.tabs.filter(function (tab_) {
                    return tab_.name === tab.name;
                })
                //不存在则添加
                if (tempTabs.length <= 0) {
                    this.tabs.push(tab)
                }
                this.activeTabName = tab.name;
            },
            removeTab: function (tabName) {
                var activeName = this.activeTabName;
                var tempTabs = this.tabs;
                if (activeName === tabName) {
                    tempTabs.forEach(function (tab, index) {
                        if (tab.name === tabName) {
                            var nextTab = tempTabs[index + 1] || tempTabs[index - 1];
                            if (nextTab) {
                                activeName = nextTab.name;
                            }
                        }
                    });
                }
                this.activeTabName = activeName;
                this.tabs = tempTabs.filter(function (tab) {
                    return tab.name !== tabName
                })
            },
            onCommand: function (cmd) {
                switch (cmd) {
                    case "logout":
                        new Ajax("system", "User").method("logout").post({}, function (response) {
                            if (response.errors.length > 0) {
                                nav.e(response.errors[0].message);
                            } else {
                                nav.clearCookie("token");
                                nav.toOpen("/login.htm");
                            }
                        }.bind(this));
                        break;
                    default:
                        nav.w("未找到对应的命令");
                        break;
                }
            },
            switchFullScreen:function(){
                this.prop.full = !this.prop.full;
                if (this.prop.full) {
                    nav.setFullScreen()
                } else {
                    nav.cancelFullScreen()
                }
            }
        },
        created: function () {
        },
        mounted: function () {
            this.onHome();//页面初始好后打开首页
            if (this.prop.full) {
                nav.setFullScreen()
            } else {
                nav.cancelFullScreen()
            }
        },
        watch: {}
    })
</script>

