<div id="app" v-cloak>
    <el-card class="box-card">
        <el-form class="search" :inline="true" :model="vm" ref="vm" label-position="right" label-width="90px">
            <el-form-item label="错误类型" prop="logErrType">
                <el-input-dict v-model="vm.logErrType" clearable size="mini" placeholder="请输入错误类型"
                               dict-name="LOG_ERR_TYPE"></el-input-dict>
            </el-form-item>
            <el-form-item label="错误标题" prop="title">
                <el-input v-model="vm.title" clearable size="mini" placeholder="请输入错误标题"></el-input>
            </el-form-item>
            <el-form-item label="处理结果" prop="logErrResult">
                <el-input-dict v-model="vm.logErrResult" clearable size="mini" placeholder="请输入处理结果"
                               dict-name="LOG_ERR_RESULT"></el-input-dict>
            </el-form-item>
            <el-form-item label="属性1" prop="attribute1">
                <el-input v-model="vm.attribute1" clearable size="mini" placeholder="请输入属性1"></el-input>
            </el-form-item>
            <el-form-item label="属性2" prop="attribute2">
                <el-input v-model="vm.attribute2" clearable size="mini" placeholder="请输入属性2"></el-input>
            </el-form-item>
            <el-form-item label="属性3" prop="attribute3">
                <el-input v-model="vm.attribute3" clearable size="mini" placeholder="请输入属性3"></el-input>
            </el-form-item>
            <el-form-item>
                <el-button type="primary" size="mini" icon="el-icon-search" @click="onSearch">搜索</el-button>
                <el-button type="warning" size="mini" icon="el-icon-refresh-left" @click="onReset('vm')">重置</el-button>
            </el-form-item>
        </el-form>
    </el-card>

    <el-card class="box-card">
        <el-row>
            <el-col :span="12">
                <el-button type="success" size="mini" icon="el-icon-check">解决</el-button>

                <el-button type="warning" size="mini" icon="el-icon-minus">搁置</el-button>
            </el-col>

            <el-col :span="12">
                <el-button-group style="float: right;">
                    <el-tooltip effect="dark" content="解决" placement="bottom">
                        <el-button size="mini" icon="el-icon-check"></el-button>
                    </el-tooltip>

                    <el-tooltip effect="dark" content="搁置" placement="bottom">
                        <el-button size="mini" icon="el-icon-minus"></el-button>
                    </el-tooltip>

                    <el-tooltip effect="dark" content="刷新" placement="bottom">
                        <el-button size="mini" icon="el-icon-refresh" @click="onFind"></el-button>
                    </el-tooltip>
                </el-button-group>
            </el-col>
        </el-row>

        <el-table
                class="data"
                @selection-change="onSelectionChange"
                empty-text="无数据"
                :data="result"
                size="mini">
            <el-table-column
                    align="center"
                    type="selection"
                    width="45">
            </el-table-column>
            <el-table-column
                    align="center"
                    prop="id"
                    label="主键"
                    width="140">
            </el-table-column>
            <el-table-column
                    align="center"
                    prop="logErrType"
                    label="错误类型">
            </el-table-column>
            <el-table-column
                    align="center"
                    prop="title"
                    label="错误标题">
            </el-table-column>
            <el-table-column
                    align="center"
                    prop="content"
                    label="错误内容">
            </el-table-column>
            <el-table-column
                    align="center"
                    prop="logErrResult"
                    label="处理结果">
            </el-table-column>
            <el-table-column
                    align="center"
                    prop="attribute1"
                    label="属性1">
            </el-table-column>
            <el-table-column
                    align="center"
                    prop="attribute2"
                    label="属性2">
            </el-table-column>
            <el-table-column
                    align="center"
                    prop="attribute3"
                    label="属性3">
            </el-table-column>
            <el-table-column
                    align="center"
                    prop="createTime"
                    width="140"
                    label="创建时间">
            </el-table-column>
            <el-table-column
                    align="center"
                    fixed="right"
                    width="120"
                    label="操作">
                <template slot-scope="scope">
                    <wb-dropdown :arg="scope.row">
                        <wb-dropdown-item value="编辑" icon="el-icon-edit" @click="onEdit"></wb-dropdown-item>
                        <wb-dropdown-item value="删除" icon="el-icon-delete" @click="onDelete"></wb-dropdown-item>
                    </wb-dropdown>
                </template>
            </el-table-column>
        </el-table>

        <el-pagination
                background
                v-if="vm.totalCount > vm.pageSize"
                style="margin-top: 10px"
                @current-change="onPageChange"
                :current-page="vm.pageNumber"
                :page-size="vm.pageSize"
                layout="total, sizes, prev, pager, next, jumper"
                :total="vm.totalCount">
        </el-pagination>
    </el-card>

    <el-dialog
            :custom-class="'dialog'"
            :title="form.title"
            :close-on-click-modal="false"
            :visible.sync="form.dialog">
        <el-form class="form" :model="form" :inline="true" :rules="formRules" ref="form" label-position="right"
                 label-width="90px">
            <el-form-item label="错误类型" prop="logErrType">
                <el-input-dict v-model="form.logErrType" clearable size="mini" placeholder="请输入错误类型"
                               dict-name="LOG_ERR_TYPE"></el-input-dict>
            </el-form-item>
            <el-form-item label="错误标题" prop="title">
                <el-input v-model="form.title" clearable size="mini" placeholder="请输入错误标题"></el-input>
            </el-form-item>
            <el-form-item label="错误内容" prop="content">
                <el-input v-model="form.content" clearable size="mini" placeholder="请输入错误内容"></el-input>
            </el-form-item>
            <el-form-item label="处理结果" prop="logErrResult">
                <el-input-dict v-model="form.logErrResult" clearable size="mini" placeholder="请输入处理结果"
                               dict-name="LOG_ERR_RESULT"></el-input-dict>
            </el-form-item>
            <el-form-item label="属性1" prop="attribute1">
                <el-input v-model="form.attribute1" clearable size="mini" placeholder="请输入属性1"></el-input>
            </el-form-item>
            <el-form-item label="属性2" prop="attribute2">
                <el-input v-model="form.attribute2" clearable size="mini" placeholder="请输入属性2"></el-input>
            </el-form-item>
            <el-form-item label="属性3" prop="attribute3">
                <el-input v-model="form.attribute3" clearable size="mini" placeholder="请输入属性3"></el-input>
            </el-form-item>
        </el-form>
        <span slot="footer" class="dialog-footer">
			<el-button size="mini" @click="form.dialog = false">取 消</el-button>
			<el-button size="mini" type="primary" @click="onSave">保存</el-button>
		</span>
    </el-dialog>
</div>
<script>
    var app = new Vue({
        mixins: [mixin],
        el: "#app",
        data: {
            module: 'system',
            target: 'logErr',
            vm: {//条件及分页参数
                logErrType: "",
                title: "",
                logErrResult: "未处理",
                attribute1: "",
                attribute2: "",
                attribute3: "",
                pageNumber: 1,
                pageSize: 10,
                totalCount: 0,
                sortKey: 'CREATE_TIME',
                sortType: 'DESC'
            },
            form: {//待提交表单
                title: "",
                dialog: false,
                id: '',
                logErrType: "",
                title: "",
                content: "",
                logErrResult: "",
                attribute1: "",
                attribute2: "",
                attribute3: "",
                rowVersion: ""
            },
            formRules: {
                logErrType: [],
                title: [
                    {required: true, message: '错误标题不能为空', trigger: 'blur'},
                    {min: 1, max: 50, message: '错误标题长度在 1 到 50 个字符', trigger: 'blur'}
                ],
                content: [],
                logErrResult: [
                    {required: true, message: '处理结果不能为空', trigger: 'blur'},
                ],
                attribute1: [
                    {min: 1, max: 50, message: '属性1长度在 1 到 50 个字符', trigger: 'blur'}
                ],
                attribute2: [
                    {min: 1, max: 50, message: '属性2长度在 1 到 50 个字符', trigger: 'blur'}
                ],
                attribute3: [
                    {min: 1, max: 50, message: '属性3长度在 1 到 50 个字符', trigger: 'blur'}
                ],
            }
        },
        methods: {
            onCreate: function () {
                this.form.title = "错误日志新增";
                this.form.dialog = true;
                this.form.id = "";
                this.form.logErrType = "";
                this.form.title = "";
                this.form.content = "";
                this.form.logErrResult = "";
                this.form.attribute1 = "";
                this.form.attribute2 = "";
                this.form.attribute3 = "";
            },
            onEdit: function (item) {
                this.form.title = "错误日志编辑";
                this.form.dialog = true;
                this.form.id = item.id;
                this.form.logErrType = item.logErrType;
                this.form.title = item.title;
                this.form.content = item.content;
                this.form.logErrResult = item.logErrResult;
                this.form.attribute1 = item.attribute1;
                this.form.attribute2 = item.attribute2;
                this.form.attribute3 = item.attribute3;
                this.form.rowVersion = item.rowVersion;
            },
            onDelete: function (item) {
                this.$confirm('将删除该项, 是否继续?', '提示', {
                    confirmButtonText: '确定',
                    cancelButtonText: '取消',
                    type: 'warning'
                }).then(function () {
                    new Ajax("system", "logErr").delete({id: item.id},function (response) {
                        if (response.errors.length > 0) {
                            nav.e(response.errors[0].message);
                        } else {
                            nav.s("删除成功");
                            this.onFind();
                        }
                    }.bind(this))
                }.bind(this)).catch(function (action) {

                });
            },
        },
        mounted: function () {
            this.onFind();
        }
    })
</script>
