<div id="app" v-cloak>
    <el-card class="box-card">
        <el-tabs :value="'list'">
            <el-tab-pane label="列表展示" name="list">
                <span slot="label"><i class="el-icon-s-operation"></i>列表展示</span>

                <el-form class="search" :inline="true" :model="vm" ref="vm" label-position="right" label-width="90px">
                    <el-form-item label="资源代码" prop="resCode">
                        <el-input v-model="vm.resCode" clearable size="mini" placeholder="请输入资源代码"></el-input>
                    </el-form-item>
                    <el-form-item label="资源名称" prop="resName">
                        <el-input v-model="vm.resName" clearable size="mini" placeholder="请输入资源名称"></el-input>
                    </el-form-item>
                    <el-form-item label="资源类型" prop="resType">
                        <el-input-dict v-model="vm.resType" clearable size="mini" placeholder="请输入资源类型"
                                       dict-name="RES_TYPE"></el-input-dict>
                    </el-form-item>
                    <el-form-item label="资源内容" prop="resValue">
                        <el-input v-model="vm.resValue" clearable size="mini" placeholder="请输入资源内容"></el-input>
                    </el-form-item>
                    <el-form-item label="是否免费" prop="free">
                        <el-radio-group v-model="vm.free" clearable size="mini">
                            <el-radio :label="true">是</el-radio>
                            <el-radio :label="false">否</el-radio>
                        </el-radio-group>
                    </el-form-item>
                    <el-form-item label="是否有效" prop="valid">
                        <el-radio-group v-model="vm.valid" clearable size="mini">
                            <el-radio :label="true">是</el-radio>
                            <el-radio :label="false">否</el-radio>
                        </el-radio-group>
                    </el-form-item>
                    <el-form-item>
                        <el-button type="primary" size="mini" icon="el-icon-search" @click="onSearch">搜索</el-button>
                        <el-button type="warning" size="mini" icon="el-icon-refresh-left" @click="onReset('vm')">重置
                        </el-button>
                    </el-form-item>
                </el-form>

                <el-divider><i class="el-icon-search"></i></el-divider>

                <el-row>
                    <el-col :span="12">
                        <el-button type="success" size="mini" icon="el-icon-plus" @click="onCreate">新增</el-button>

                        <el-button type="warning" size="mini" icon="el-icon-download" @click="onExport">导出</el-button>
                    </el-col>

                    <el-col :span="12">
                        <el-button-group style="float: right;">
                            <el-tooltip effect="dark" content="Excel模板下载" placement="bottom">
                                <el-button size="mini" icon="el-icon-date" @click="onTemplate"></el-button>
                            </el-tooltip>

                            <el-tooltip effect="dark" content="Excel导入" placement="bottom">
                                <el-button size="mini" icon="el-icon-upload2" @click="onImport"></el-button>
                            </el-tooltip>

                            <el-tooltip effect="dark" content="批量删除" placement="bottom">
                                <el-button size="mini" icon="el-icon-delete" @click="onBitchDelete"></el-button>
                            </el-tooltip>

                            <el-tooltip effect="dark" content="刷新" placement="bottom">
                                <el-button size="mini" icon="el-icon-refresh" @click="onFind"></el-button>
                            </el-tooltip>
                        </el-button-group>
                    </el-col>
                </el-row>

                <el-table
                        @selection-change="onSelectionChange"
                        empty-text="无数据"
                        :data="result"
                        size="mini">
                    <el-table-column
                            align="center"
                            type="selection"
                            width="45">
                    </el-table-column>
                    <el-table-column
                            align="center"
                            prop="id"
                            label="主键"
                            width="140">
                    </el-table-column>
                    <el-table-column
                            align="center"
                            prop="valid"
                            label="是否有效"
                            width="80">
                        <template slot-scope="scope">
                            <el-tag size="mini" effect="dark" type="success" v-if="scope.row.valid">有效</el-tag>
                            <el-tag size="mini" effect="dark" type="danger" v-if="!scope.row.valid">无效</el-tag>
                        </template>
                    </el-table-column>
                    <el-table-column
                            align="center"
                            prop="resCode"
                            width="100"
                            label="资源代码">
                    </el-table-column>
                    <el-table-column
                            align="center"
                            prop="resName"
                            label="资源名称">
                    </el-table-column>
                    <el-table-column
                            align="center"
                            prop="resType"
                            label="资源类型">
                    </el-table-column>
                    <el-table-column
                            align="center"
                            prop="resValue"
                            width="200"
                            label="资源内容">
                    </el-table-column>
                    <el-table-column
                            align="center"
                            prop="free"
                            label="是否免费">
                        <template slot-scope="scope">
                            <el-tag size="mini" effect="dark" type="success" v-if="scope.row.free">免费</el-tag>
                            <el-tag size="mini" effect="dark" type="danger" v-if="!scope.row.free">授权</el-tag>
                        </template>
                    </el-table-column>
                    <el-table-column
                            align="center"
                            prop="createTime"
                            width="140"
                            label="创建时间">
                    </el-table-column>
                    <el-table-column
                            align="center"
                            fixed="right"
                            width="120"
                            label="操作">
                        <template slot-scope="scope">
                            <wb-dropdown :arg="scope.row">
                                <wb-dropdown-item value="编辑" icon="el-icon-edit" @click="onEdit"></wb-dropdown-item>
                                <wb-dropdown-item value="删除" icon="el-icon-delete" @click="onDelete"></wb-dropdown-item>
                            </wb-dropdown>
                        </template>
                    </el-table-column>
                </el-table>

                <el-pagination
                        background
                        v-if="vm.totalCount > vm.pageSize"
                        style="margin-top: 10px"
                        @current-change="onPageChange"
                        @size-change="onPageSizeChange"
                        :current-page="vm.pageNumber"
                        :page-size="vm.pageSize"
                        layout="total, sizes, prev, pager, next, jumper"
                        :total="vm.totalCount">
                </el-pagination>

            </el-tab-pane>
            <el-tab-pane label="树状展示" name="tree">
                <span slot="label"><i class="el-icon-share"></i>树状展示</span>

                <el-row>
                    <el-col :span="12">
                        <el-input v-model="treeKeyword" clearable size="mini" placeholder="请输入资源内容" @change="onChange"
                                  style="width: 200px;"></el-input>
                    </el-col>
                    <el-col :span="12">
                        <el-button-group style="float: right;">
                            <el-tooltip effect="dark" content="批量删除" placement="bottom">
                                <el-button size="mini" icon="el-icon-delete" @click="onBitchDelete"></el-button>
                            </el-tooltip>

                            <el-tooltip effect="dark" content="刷新" placement="bottom">
                                <el-button size="mini" icon="el-icon-refresh" @click="onLoadTree"></el-button>
                            </el-tooltip>
                        </el-button-group>
                    </el-col>
                </el-row>

                <el-tree
                        style="margin-top: 10px"
                        :data="treeData"
                        node-key="resCode"
                        ref="tree"
                        default-expand-all
                        :filter-node-method="filterTree"
                        :expand-on-click-node="false">
                    <div class="tree" slot-scope="{ node, data }">
                        <span>
                            <el-button type="text" size="mini" icon="el-icon-plus"
                                       @click="onTreeCreate(data)"></el-button>
                            {{ data.resName }}<span style="color: #409EFF"
                                                    @click="onTreeEdit(data)">[{{data.resCode}}]</span>
                        </span>
                    </div>
                </el-tree>
            </el-tab-pane>
        </el-tabs>
    </el-card>

    <el-dialog
            :custom-class="'dialog'"
            :title="form.title"
            :close-on-click-modal="false"
            :visible.sync="form.dialog">
        <el-form class=form" :model="form" :inline="true" :rules="formRules" ref="form"
                 label-position="right" label-width="90px">
            <el-form-item label="资源代码" prop="resCode">
                <el-input v-model="form.resCode" clearable size="mini"
                          placeholder="请输入资源代码"></el-input>
            </el-form-item>
            <el-form-item label="资源名称" prop="resName">
                <el-input v-model="form.resName" clearable size="mini"
                          placeholder="请输入资源名称"></el-input>
            </el-form-item>
            <el-form-item label="资源类型" prop="resType">
                <el-input-dict v-model="form.resType" clearable size="mini"
                               placeholder="请输入资源类型"
                               dict-name="RES_TYPE"></el-input-dict>
            </el-form-item>
            <el-form-item label="资源内容" prop="resValue">
                <el-input v-model="form.resValue" clearable size="mini"
                          placeholder="请输入资源描述"></el-input>
            </el-form-item>
            <el-form-item label="是否免费" prop="free">
                <el-switch v-model="form.free" active-text="免费" inactive-text="授权" clearable size="mini"></el-switch>
            </el-form-item>
            <el-form-item label="是否有效" prop="valid">
                <el-radio-group v-model="form.valid" clearable size="mini">
                    <el-radio :label="true">是</el-radio>
                    <el-radio :label="false">否</el-radio>
                </el-radio-group>
            </el-form-item>
        </el-form>
        <span slot="footer" class="dialog-footer">
            <el-button size="mini" @click="form.dialog = false">取 消</el-button>
            <el-button size="mini" type="primary" @click="onSave">保存</el-button>
        </span>
    </el-dialog>
</div>
<style>
    .tree {
        flex: auto;
        display: flex;
        align-items: center;
        justify-content: space-between;
        font-size: 14px;
        padding-right: 8px;
    }
</style>
<script>
    var app = new Vue({
        mixins: [mixin],
        el: "#app",
        data: {
            module: 'system',
            target: 'res',
            vm: {//条件及分页参数
                resCode: "",
                resName: "",
                resType: "",
                resValue: "",
                free: "",
                valid: "",
                pageNumber: 1,
                pageSize: 10,
                totalCount: 0,
                sortKey: 'CREATE_TIME',
                sortType: 'DESC'
            },
            form: {//待提交表单
                title: "",
                dialog: false,
                id: '',
                resCode: "",
                resName: "",
                resType: "",
                resValue: "",
                free: "",
                valid: "",
                rowVersion: ""
            },
            formRules: {
                resCode: [
                    {required: true, message: '资源代码不能为空', trigger: 'blur'},
                    {min: 1, max: 50, message: '资源代码长度在 1 到 50 个字符', trigger: 'blur'}
                ],
                resName: [
                    {required: true, message: '资源名称不能为空', trigger: 'blur'},
                    {min: 1, max: 50, message: '资源名称长度在 1 到 50 个字符', trigger: 'blur'}
                ],
                resType: [
                    {required: true, message: '资源类型不能为空', trigger: 'blur'},
                ],
                resValue: [
                    {min: 1, max: 255, message: '资源内容长度在 1 到 255 个字符', trigger: 'blur'}
                ],
                free: [
                    {required: true, message: '是否免费不能为空', trigger: 'blur'},
                ],
                valid: [
                    {required: true, message: '是否有效不能为空', trigger: 'blur'},
                ],
            },
            treeKeyword: '',
            treeData: []
        },
        methods: {
            onCreate: function () {
                this.form.title = "资源新增";
                this.form.dialog = true;
                this.form.id = "";
                this.form.resCode = "";
                this.form.resName = "";
                this.form.resType = "";
                this.form.resValue = "";
                this.form.free = false;
                this.form.valid = true;
            },
            onEdit: function (item) {
                this.form.title = "资源编辑";
                this.form.dialog = true;
                this.form.id = item.id;
                this.form.resCode = item.resCode;
                this.form.resName = item.resName;
                this.form.resType = item.resType;
                this.form.resValue = item.resValue;
                this.form.free = item.free;
                this.form.valid = item.valid;
                this.form.rowVersion = item.rowVersion;
            },
            onDelete: function (item) {
                this.$confirm('将删除该项, 是否继续?', '提示', {
                    confirmButtonText: '确定',
                    cancelButtonText: '取消',
                    type: 'warning'
                }).then(function () {
                    new Ajax("system", "res").delete({id: item.id}, function (response) {
                        if (response.errors.length > 0) {
                            nav.e(response.errors[0].message);
                        } else {
                            nav.s("删除成功");
                            this.onFind();
                        }
                    }.bind(this))
                }.bind(this)).catch(function (action) {

                });
            },
            onTreeCreate: function (pItem) {
                this.form.title = "资源新增";
                this.form.dialog = true;
                this.form.id = "";
                this.form.resCode = pItem.resCode;
                this.form.resName = "";
                this.form.resType = "";
                this.form.resValue = "";
                this.form.free = false;
                this.form.valid = true;
            },
            onTreeEdit: function (pItem) {
                this.form.title = "资源编辑";
                this.form.dialog = true;
                this.form.id = pItem.id;
                this.form.resCode = pItem.resCode;
                this.form.resName = pItem.resName;
                this.form.resType = pItem.resType;
                this.form.resValue = pItem.resValue;
                this.form.free = pItem.free;
                this.form.valid = pItem.valid;
                this.form.rowVersion = pItem.rowVersion;
            },
            onChange: function (value) {
                this.$refs.tree.filter(value);
            },
            filterTree: function (value, data) {
                if (!value) return true;
                return data.comment.indexOf(value) !== -1;
            },
            onLoadTree: function () {
                new Ajax("system", "res").method("tree").post({}, function (response) {
                    if (response.errors.length > 0) {
                        nav.e(response.errors[0].message);
                    } else {
                        this.treeData = response.result;
                    }
                }.bind(this))
            },
            onSave: function () {
                this.$refs['form'].validate(function (valid) {
                    if (valid) {
                        if (this.form.id) {
                            new Ajax("system", "res").update(this.form, function (response) {
                                if (response.errors.length > 0) {
                                    nav.e(response.errors[0].message);
                                } else {
                                    this.onFind();
                                    this.onLoadTree();
                                    this.$refs['form'].resetFields();
                                    this.form.dialog = false;
                                }
                            }.bind(this))
                        } else {
                            new Ajax("system", "res").create(this.form, function (response) {
                                if (response.errors.length > 0) {
                                    nav.e(response.errors[0].message);
                                } else {
                                    this.onFind();
                                    this.onLoadTree();
                                    this.$refs['form'].resetFields();
                                    this.form.dialog = false;
                                }
                            }.bind(this))
                        }
                    } else {
                        return false;
                    }
                }.bind(this));
            },
        },
        watch: {
            treeKeyword: function (val) {
                this.$refs.tree.filter(val);
            }
        },
        mounted: function () {
            this.onFind();
            this.onLoadTree();
        }
    })
</script>
