-- ----------------------------
-- Table structure for DICT - 字典
-- Target   : MySQL
-- Author   : wangbing
-- Date:    : 2020-01-08
-- ----------------------------
CREATE TABLE `SYS_DICT` (
    `ID` BIGINT(20) NOT NULL COMMENT '主键',
    `DICT_NAME` VARCHAR(50) COMMENT '字典名称',
    `DICT_COMMENT` VARCHAR(50) COMMENT '字典描述',
    `VERSION` VARCHAR(50) COMMENT '字典版本',
    `VALID` TINYINT(1) COMMENT '是否有效',
    `ROW_VERSION` BIGINT(20) NOT NULL DEFAULT 0 COMMENT '行版本',
    `IS_DELETED` TINYINT(1) NOT NULL DEFAULT 0 COMMENT '是否已删除',
    `CREATE_BY` BIGINT(20) NOT NULL COMMENT '创建用户',
    `CREATE_TIME` DATETIME NOT NULL COMMENT '创建时间',
    `LAST_UPDATE_BY` BIGINT(20) DEFAULT NULL COMMENT '最后更新用户',
    `LAST_UPDATE_TIME` DATETIME DEFAULT NULL COMMENT '最后更新时间',
PRIMARY KEY (`ID`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='字典';

-- ----------------------------
-- Table structure for DICT_ITEM - 字典项
-- Target   : MySQL
-- Author   : wangbing
-- Date:    : 2020-01-08
-- ----------------------------
CREATE TABLE `SYS_DICT_ITEM` (
    `ID` BIGINT(20) NOT NULL COMMENT '主键',
    `DICT_NAME` VARCHAR(50) COMMENT '字典名称',
    `KEY` VARCHAR(20) COMMENT '字典键',
    `VALUE` VARCHAR(50) COMMENT '字典值',
    `SORT` INTEGER(10) COMMENT '排序',
    `VALID` TINYINT(1) COMMENT '是否有效',
    `ROW_VERSION` BIGINT(20) NOT NULL DEFAULT 0 COMMENT '行版本',
    `IS_DELETED` TINYINT(1) NOT NULL DEFAULT 0 COMMENT '是否已删除',
    `CREATE_BY` BIGINT(20) NOT NULL COMMENT '创建用户',
    `CREATE_TIME` DATETIME NOT NULL COMMENT '创建时间',
    `LAST_UPDATE_BY` BIGINT(20) DEFAULT NULL COMMENT '最后更新用户',
    `LAST_UPDATE_TIME` DATETIME DEFAULT NULL COMMENT '最后更新时间',
PRIMARY KEY (`ID`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='字典项';

-- ----------------------------
-- Table structure for RES - 资源
-- Target   : MySQL
-- Author   : wangbing
-- Date:    : 2020-01-08
-- ----------------------------
CREATE TABLE `SYS_RES` (
    `ID` BIGINT(20) NOT NULL COMMENT '主键',
    `RES_CODE` VARCHAR(50) NOT NULL COMMENT '资源代码',
    `RES_NAME` VARCHAR(50) NOT NULL COMMENT '资源名称',
    `RES_TYPE` VARCHAR(20) NOT NULL COMMENT '资源类型',
    `RES_VALUE` VARCHAR(250) COMMENT '资源内容',
    `SUP_CODE` VARCHAR(50) COMMENT '上级代码',
    `SUP_NAME` VARCHAR(50) COMMENT '上级名称',
    `VALID` TINYINT(1) NOT NULL COMMENT '是否有效',
    `ROW_VERSION` BIGINT(20) NOT NULL DEFAULT 0 COMMENT '行版本',
    `IS_DELETED` TINYINT(1) NOT NULL DEFAULT 0 COMMENT '是否已删除',
    `CREATE_BY` BIGINT(20) NOT NULL COMMENT '创建用户',
    `CREATE_TIME` DATETIME NOT NULL COMMENT '创建时间',
    `LAST_UPDATE_BY` BIGINT(20) DEFAULT NULL COMMENT '最后更新用户',
    `LAST_UPDATE_TIME` DATETIME DEFAULT NULL COMMENT '最后更新时间',
PRIMARY KEY (`ID`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='资源';

-- ----------------------------
-- Table structure for USER - 用户
-- Target   : MySQL
-- Author   : wangbing
-- Date:    : 2020-01-08
-- ----------------------------
CREATE TABLE `SYS_USER` (
    `ID` BIGINT(20) NOT NULL COMMENT '主键',
    `USER_NAME` VARCHAR(100) NOT NULL COMMENT '用户账户',
    `USER_CODE` VARCHAR(50) NOT NULL COMMENT '用户代码',
    `USER_ALIAS` VARCHAR(50) COMMENT '用户别名',
    `USER_PWD` VARCHAR(50) NOT NULL COMMENT '用户密码',
    `USER_STATUS` VARCHAR(20) NOT NULL COMMENT '用户状态',
    `DEPT_ID` BIGINT(20) COMMENT '部门主键',
    `DEPT_CODE` VARCHAR(50) COMMENT '部门代码',
    `DEPT_NAME` VARCHAR(100) COMMENT '部门名称',
    `ROW_VERSION` BIGINT(20) NOT NULL DEFAULT 0 COMMENT '行版本',
    `IS_DELETED` TINYINT(1) NOT NULL DEFAULT 0 COMMENT '是否已删除',
    `CREATE_BY` BIGINT(20) NOT NULL COMMENT '创建用户',
    `CREATE_TIME` DATETIME NOT NULL COMMENT '创建时间',
    `LAST_UPDATE_BY` BIGINT(20) DEFAULT NULL COMMENT '最后更新用户',
    `LAST_UPDATE_TIME` DATETIME DEFAULT NULL COMMENT '最后更新时间',
PRIMARY KEY (`ID`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='用户';

-- ----------------------------
-- Table structure for DEPT - 部门
-- Target   : MySQL
-- Author   : wangbing
-- Date:    : 2020-01-08
-- ----------------------------
CREATE TABLE `SYS_DEPT` (
    `ID` BIGINT(20) NOT NULL COMMENT '主键',
    `DEPT_CODE` VARCHAR(50) NOT NULL COMMENT '部门代码',
    `DEPT_NAME` VARCHAR(100) NOT NULL COMMENT '部门名称',
    `DEPT_ALIAS` VARCHAR(50) COMMENT '部门别名',
    `SUP_CODE` VARCHAR(50) COMMENT '上级代码',
    `SUP_NAME` VARCHAR(100) COMMENT '上级名称',
    `VALID` TINYINT(1) NOT NULL COMMENT '是否有效',
    `ROW_VERSION` BIGINT(20) NOT NULL DEFAULT 0 COMMENT '行版本',
    `IS_DELETED` TINYINT(1) NOT NULL DEFAULT 0 COMMENT '是否已删除',
    `CREATE_BY` BIGINT(20) NOT NULL COMMENT '创建用户',
    `CREATE_TIME` DATETIME NOT NULL COMMENT '创建时间',
    `LAST_UPDATE_BY` BIGINT(20) DEFAULT NULL COMMENT '最后更新用户',
    `LAST_UPDATE_TIME` DATETIME DEFAULT NULL COMMENT '最后更新时间',
PRIMARY KEY (`ID`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='部门';

-- ----------------------------
-- Table structure for ROLE - 角色
-- Target   : MySQL
-- Author   : wangbing
-- Date:    : 2020-01-08
-- ----------------------------
CREATE TABLE `SYS_ROLE` (
    `ID` BIGINT(20) NOT NULL COMMENT '主键',
    `CODE` VARCHAR(50) NOT NULL COMMENT '角色代码',
    `NAME` VARCHAR(50) NOT NULL COMMENT '角色名称',
    `COMMENT` VARCHAR(50) COMMENT '角色描述',
    `ROW_VERSION` BIGINT(20) NOT NULL DEFAULT 0 COMMENT '行版本',
    `IS_DELETED` TINYINT(1) NOT NULL DEFAULT 0 COMMENT '是否已删除',
    `CREATE_BY` BIGINT(20) NOT NULL COMMENT '创建用户',
    `CREATE_TIME` DATETIME NOT NULL COMMENT '创建时间',
    `LAST_UPDATE_BY` BIGINT(20) DEFAULT NULL COMMENT '最后更新用户',
    `LAST_UPDATE_TIME` DATETIME DEFAULT NULL COMMENT '最后更新时间',
PRIMARY KEY (`ID`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='角色';

-- ----------------------------
-- Table structure for TOKENS - 通行证
-- Target   : MySQL
-- Author   : wangbing
-- Date:    : 2020-01-08
-- ----------------------------
CREATE TABLE `SYS_TOKENS` (
    `ID` BIGINT(20) NOT NULL COMMENT '主键',
    `TOKEN` VARCHAR(50) NOT NULL COMMENT '登录令牌',
    `USER_ID` BIGINT(20) NOT NULL COMMENT '用户主键',
    `USER_NAME` VARCHAR(50) NOT NULL COMMENT '用户名称',
    `LOGIN_TIME` DATETIME NOT NULL COMMENT '登录时间',
    `VALID_TIME` DATETIME NOT NULL COMMENT '有效时间',
    `VALID` TINYINT(1) NOT NULL COMMENT '是否有效',
    `DEPT_ID` BIGINT(20) COMMENT '部门主键',
    `DEPT_CODE` VARCHAR(50) COMMENT '部门代码',
    `DEPT_NAME` VARCHAR(100) COMMENT '部门名称',
    `TERMINAL_TYPE` VARCHAR(20) COMMENT '终端类型',
    `TERMINAL_IP` VARCHAR(50) COMMENT '终端地址',
    `TERMINAL_INFO` VARCHAR(500) COMMENT '终端信息',
    `ROW_VERSION` BIGINT(20) NOT NULL DEFAULT 0 COMMENT '行版本',
    `IS_DELETED` TINYINT(1) NOT NULL DEFAULT 0 COMMENT '是否已删除',
    `CREATE_BY` BIGINT(20) NOT NULL COMMENT '创建用户',
    `CREATE_TIME` DATETIME NOT NULL COMMENT '创建时间',
    `LAST_UPDATE_BY` BIGINT(20) DEFAULT NULL COMMENT '最后更新用户',
    `LAST_UPDATE_TIME` DATETIME DEFAULT NULL COMMENT '最后更新时间',
PRIMARY KEY (`ID`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='通行证';

-- ----------------------------
-- Table structure for FILE - 文件
-- Target   : MySQL
-- Author   : wangbing
-- Date:    : 2020-01-08
-- ----------------------------
CREATE TABLE `SYS_FILE` (
    `ID` BIGINT(20) NOT NULL COMMENT '主键',
    `NAME` VARCHAR(250) COMMENT '文件名称',
    `FILE_TYPE` VARCHAR(20) COMMENT '文件类型',
    `ATTRIBUTE1` VARCHAR(50) COMMENT '扩展属性1',
    `ATTRIBUTE2` VARCHAR(50) COMMENT '扩展属性2',
    `LOCATION` VARCHAR(500) COMMENT '存放地址',
    `URL` VARCHAR(500) COMMENT '访问地址',
    `URL_DOWNLOAD` VARCHAR(500) COMMENT '下载地址',
    `ROW_VERSION` BIGINT(20) NOT NULL DEFAULT 0 COMMENT '行版本',
    `IS_DELETED` TINYINT(1) NOT NULL DEFAULT 0 COMMENT '是否已删除',
    `CREATE_BY` BIGINT(20) NOT NULL COMMENT '创建用户',
    `CREATE_TIME` DATETIME NOT NULL COMMENT '创建时间',
    `LAST_UPDATE_BY` BIGINT(20) DEFAULT NULL COMMENT '最后更新用户',
    `LAST_UPDATE_TIME` DATETIME DEFAULT NULL COMMENT '最后更新时间',
PRIMARY KEY (`ID`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='文件';

-- ----------------------------
-- Table structure for USER_ROLE - 用户角色授权
-- Target   : MySQL
-- Author   : wangbing
-- Date:    : 2020-01-08
-- ----------------------------
CREATE TABLE `SYS_USER_ROLE` (
    `ID` BIGINT(20) NOT NULL COMMENT '主键',
    `USER_ID` BIGINT(20) NOT NULL COMMENT '用户主键',
    `USER_CODE` VARCHAR(50) NOT NULL COMMENT '用户代码',
    `ROLE_ID` BIGINT(20) NOT NULL COMMENT '角色主键',
    `ROLE_CODE` VARCHAR(50) NOT NULL COMMENT '角色代码',
    `ROW_VERSION` BIGINT(20) NOT NULL DEFAULT 0 COMMENT '行版本',
    `IS_DELETED` TINYINT(1) NOT NULL DEFAULT 0 COMMENT '是否已删除',
    `CREATE_BY` BIGINT(20) NOT NULL COMMENT '创建用户',
    `CREATE_TIME` DATETIME NOT NULL COMMENT '创建时间',
    `LAST_UPDATE_BY` BIGINT(20) DEFAULT NULL COMMENT '最后更新用户',
    `LAST_UPDATE_TIME` DATETIME DEFAULT NULL COMMENT '最后更新时间',
PRIMARY KEY (`ID`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='用户角色授权';

-- ----------------------------
-- Table structure for ROLE_RES - 角色资源关系
-- Target   : MySQL
-- Author   : wangbing
-- Date:    : 2020-01-08
-- ----------------------------
CREATE TABLE `SYS_ROLE_RES` (
    `ID` BIGINT(20) NOT NULL COMMENT '主键',
    `ROLE_ID` BIGINT(20) NOT NULL COMMENT '角色主键',
    `ROLE_CODE` VARCHAR(50) NOT NULL COMMENT '角色代码',
    `RES_ID` BIGINT(20) NOT NULL COMMENT '资源主键',
    `RES_CODE` VARCHAR(50) NOT NULL COMMENT '资源代码',
    `ROW_VERSION` BIGINT(20) NOT NULL DEFAULT 0 COMMENT '行版本',
    `IS_DELETED` TINYINT(1) NOT NULL DEFAULT 0 COMMENT '是否已删除',
    `CREATE_BY` BIGINT(20) NOT NULL COMMENT '创建用户',
    `CREATE_TIME` DATETIME NOT NULL COMMENT '创建时间',
    `LAST_UPDATE_BY` BIGINT(20) DEFAULT NULL COMMENT '最后更新用户',
    `LAST_UPDATE_TIME` DATETIME DEFAULT NULL COMMENT '最后更新时间',
PRIMARY KEY (`ID`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='角色资源关系';

