package example;


import java.util.ArrayList;
import java.util.List;

import xyz.wbsite.base.BaseSPAFragment;

public class IconManager {
    private Icon rootIcon = new Icon(0, null, null);
    private List<Icon> allIcon = new ArrayList<>();

    public void addIcon(Icon icon) {
        this.rootIcon.addChild(icon);
    }

    public void addIcon(int parentId, Icon icon) {
        if (0 == parentId) {
            addIcon(icon);
        } else {
            for (Icon i : allIcon) {
                if (parentId == i.iconId) {
                    i.addChild(icon);
                }
            }
        }
    }

    public List<Icon> inflate(int... i) {
        if (i.length == 0) {
            return allIcon;
        } else {
            List<Icon> icons = new ArrayList<>();
            for (int i1 : i) {
                for (Icon icon : allIcon) {
                    if (i1 == icon.iconId) {
                        icons.addAll(icon.childIcons);
                    }
                }
            }
            return icons;
        }
    }

    int countChlid(List<Icon> icons) {
        int count = 0;

        for (Icon icon : icons) {
            count += icon.labelCount;
            if (icon.getChildIcons() != null && icon.getChildIcons().size() > 0) {
                count += countChlid(icon.getChildIcons());
            }
        }
        return count;
    }

    public class Icon {
        int iconId;
        String labelName;
        int labelCount;
        BaseSPAFragment targetfragment;
        private List<Icon> childIcons = new ArrayList<>();

        List<Icon> getChildIcons() {
            return childIcons;
        }

        Icon(int iconId, String labelName, BaseSPAFragment targetfragment) {
            this(iconId, labelName, 0, targetfragment);
        }

        Icon(int iconId, String labelName, int labelCount, BaseSPAFragment targetfragment) {
            this.iconId = iconId;
            this.labelName = labelName;
            this.labelCount = labelCount;
            this.targetfragment = targetfragment;
        }

        void addChild(Icon icon) {
            childIcons.add(icon);
            allIcon.add(icon);
        }

        public int getIconId() {
            return iconId;
        }

        public void setIconId(int iconId) {
            this.iconId = iconId;
        }

        public String getLabelName() {
            return labelName;
        }

        public void setLabelName(String labelName) {
            this.labelName = labelName;
        }

        public int getLabelCount() {
            return labelCount + countChlid(childIcons);
        }

        public void setLabelCount(int labelCount) {
            this.labelCount = labelCount;
        }

        public BaseSPAFragment getTargetfragment() {
            return targetfragment;
        }
    }
}


