package example;

import android.Manifest;
import android.os.Bundle;
import android.support.v4.app.Fragment;

import com.qmuiteam.qmui.arch.QMUIFragment;
import com.qmuiteam.qmui.util.QMUIStatusBarHelper;
import com.yanzhenjie.permission.Action;
import com.yanzhenjie.permission.AndPermission;

import java.util.List;

import example.fragment.MainFragment;
import xyz.wbsite.base.BaseSPAActivity;
import xyz.wbsite.wbui.R;

public class WBUIMainActivity extends BaseSPAActivity {

    private MainFragment mainFragment;

    @Override
    protected int getContextViewId() {
        return R.id.main_id;
    }

    @Override
    protected void onCreate(Bundle savedInstanceState) {
        super.onCreate(savedInstanceState);
        QMUIStatusBarHelper.setStatusBarLightMode(this);
        AndPermission.with(this).runtime().permission(Manifest.permission.READ_EXTERNAL_STORAGE).onGranted(new Action<List<String>>() {
            @Override
            public void onAction(List<String> data) {
                startFirstFragment();
            }
        }).onDenied(new Action<List<String>>() {
            @Override
            public void onAction(List<String> data) {
                startFirstFragment();
                WBUIApplication.getInstance().lozyInit();
            }
        }).start();
    }

    private void startFirstFragment() {
        mainFragment = new MainFragment();
        getSupportFragmentManager()
                .beginTransaction()
                .add(getContextViewId(), mainFragment, mainFragment.getClass().getSimpleName())
                .addToBackStack(mainFragment.getClass().getSimpleName())
                .commit();
    }

    @Override
    public void onBackPressed() {
        QMUIFragment currentFragment = getCurrentFragment();
        if (currentFragment instanceof MainFragment && mainFragment.isFunFragment()) {
            WBUIApplication.getInstance().exit();
        } else if (!mainFragment.isFunFragment()) {
            mainFragment.setFunFragment();
        } else {
            super.onBackPressed();
        }
    }
}

