package example.fragment;


import android.app.Activity;
import android.content.Intent;
import android.os.Bundle;
import android.support.annotation.NonNull;
import android.view.LayoutInflater;
import android.view.View;
import android.view.ViewGroup;
import android.widget.AdapterView;
import android.widget.BaseAdapter;
import android.widget.ImageView;
import android.widget.TextView;

import com.qmuiteam.qmui.widget.QMUITopBarLayout;
import com.qmuiteam.qmui.widget.dialog.QMUIDialog;
import com.qmuiteam.qmui.widget.dialog.QMUIDialogAction;
import com.vector.update_app.HttpManager;
import com.vector.update_app.UpdateAppManager;
import com.vector.update_app.UpdateCallback;
import com.vector.update_app.listener.ExceptionHandler;

import org.json.JSONException;
import org.json.JSONObject;

import java.util.ArrayList;
import java.util.List;
import java.util.Map;

import butterknife.BindView;
import butterknife.ButterKnife;
import example.IconManager;
import example.WBUIApplication;
import xyz.wbsite.activity.QRcodeActivity;
import xyz.wbsite.base.BaseSPAFragment;
import xyz.wbsite.base.IActivityResult;
import xyz.wbsite.service.RestartService;
import xyz.wbsite.util.DialogUtil;
import xyz.wbsite.util.StorageUtil;
import xyz.wbsite.util.Toaster;
import xyz.wbsite.wbui.R;
import xyz.wbsite.wbui.layout.WBUIBorderGridView;

public class FunFragment extends BaseSPAFragment {

    @BindView(R.id.gridMenu)
    WBUIBorderGridView gridMenu;
    @BindView(R.id.topBar)
    QMUITopBarLayout topBar;

    Adapter adapter = new Adapter();
    IconManager iconManager;
    List<IconManager.Icon> currentIcon = new ArrayList<>();

    String title;
    int parentId;

    @Override
    protected int getFragmnetLayout() {
        return R.layout.fragment_functions;
    }


    @Override
    protected void onViewInit() {
        topBar.setTitle("组件");

        iconManager = WBUIApplication.getInstance().getIconManager();
        currentIcon = iconManager.inflate();

        gridMenu.setAdapter(adapter);
        gridMenu.setOnItemClickListener(new AdapterView.OnItemClickListener() {
            @Override
            public void onItemClick(AdapterView<?> adapterView, View view, final int i, long l) {
                IconManager.Icon icon = currentIcon.get(i);
                BaseSPAFragment targetfragment = icon.getTargetfragment();
                if (targetfragment != null) {
                    startFragment(targetfragment);
                } else {
                    switch (icon.getIconId()) {
                        case R.drawable.icon_fun_qrcode:
                            startForResult(new Intent(getContext(), QRcodeActivity.class), new IActivityResult() {
                                @Override
                                public void onResult(int resultCode, Intent data) {
                                    if (Activity.RESULT_OK == resultCode) {
                                        String stringExtra = data.getStringExtra(QRcodeActivity.QRCODE_RESULT);
                                        Toaster.showToast("扫描结果:" + stringExtra);
                                    } else {
                                        Toaster.showToast("扫描失败或已取消");
                                    }
                                }
                            });
                            break;
                        case R.drawable.icon_fun_restart:
                            DialogUtil.showMessage(getContext(), "是否确认重启程序", "", new DialogUtil.MessageListener() {
                                @Override
                                public void onCallback(boolean positive) {
                                    if (positive){
                                        RestartService.restartAPP(getContext(), 1000);
                                    }
                                }
                            });
                            break;
                        case R.drawable.icon_fun_upgrade: {

                            new UpdateAppManager
                                    .Builder()
                                    //必须设置，当前Activity
                                    .setActivity(getActivity())
                                    //必须设置，更新地址
                                    .setUpdateUrl("http://example")
                                    //以下设置，都是可选
                                    //设置请求方式，默认get
                                    .setPost(true)
                                    .setAppKey("AppKey")
                                    //设置apk下砸路径，默认是在下载到sd卡下/Download/1.0.0/test.apk
                                    .setTargetPath(StorageUtil.getLocalDir(getContext(), "Download/apk/test.apk").getAbsolutePath())
                                    //必须设置，实现httpManager接口的对象
                                    .setHttpManager(new HttpManager() {
                                        @Override
                                        public void asyncGet(@NonNull String url, @NonNull Map<String, String> params, @NonNull Callback callBack) {

                                        }

                                        @Override
                                        public void asyncPost(@NonNull String url, @NonNull Map<String, String> params, @NonNull Callback callBack) {
                                            JSONObject jsonObject = new JSONObject();
                                            try {
                                                jsonObject.put("update", "Yes");//是否有新版本
                                                jsonObject.put("constraint", "false");//强制更新
                                                jsonObject.put("new_version", "v1.0.0");//新版本号
                                                jsonObject.put("apk_file_url", "/1.0.0/test.apk");//下载地址
                                                jsonObject.put("update_log", "1、修复闪退BUG");//更新内容
                                                callBack.onResponse(jsonObject.toString());
                                            } catch (JSONException e) {
                                                e.printStackTrace();
                                                callBack.onError("");
                                            }
                                        }

                                        @Override
                                        public void download(@NonNull String url, @NonNull String path, @NonNull String fileName, @NonNull final FileCallback callback) {
                                            callback.onBefore();

                                            new Thread() {
                                                @Override
                                                public void run() {
                                                    for (int j = 0; j < 10; j++) {
                                                        try {
                                                            Thread.sleep(1000);
                                                        } catch (InterruptedException e) {
                                                            e.printStackTrace();
                                                        }
                                                        final int finalJ = j;
                                                        handler.post(new Runnable() {
                                                            @Override
                                                            public void run() {
                                                                callback.onProgress(finalJ / 10f, 1000);
                                                            }
                                                        });
                                                    }
                                                    handler.post(new Runnable() {
                                                        @Override
                                                        public void run() {
                                                            callback.onResponse(StorageUtil.getLocalDir(getContext(), "Download/apk/test.apk"));
                                                        }
                                                    });
                                                }
                                            }.start();
                                        }
                                    })
                                    .handleException(new ExceptionHandler() {
                                        @Override
                                        public void onException(Exception e) {
                                            e.printStackTrace();
                                            handler.post(new Runnable() {
                                                @Override
                                                public void run() {
                                                    Toaster.showToast("更新出现了一些错误");
                                                }
                                            });
                                        }
                                    })
                                    .build()
                                    //检测是否有新版本
                                    .checkNewApp(new UpdateCallback());

                        }

                        break;
                    }
                }
            }
        });
    }

    @Override
    protected void onDataSave(Bundle data) {

    }

    @Override
    protected void onDataInit(Bundle data) {

    }

    class Adapter extends BaseAdapter {

        @Override
        public int getCount() {
            return currentIcon.size();
        }

        @Override
        public Object getItem(int i) {
            return currentIcon.get(i);
        }

        @Override
        public long getItemId(int i) {
            return i;
        }

        @Override
        public View getView(int i, View view, ViewGroup viewGroup) {

            View view_;
            ViewHolder holder;
            IconManager.Icon item = currentIcon.get(i);
            // 判断convertView的状态，来达到复用效果
            if (null == view) {
                view_ = LayoutInflater.from(getActivity()).inflate(R.layout.item_grid_menu, null);
                holder = new ViewHolder(view_);
                view_.setTag(holder);
            } else {
                // 否则表示可以复用convertView
                view_ = view;
                holder = (ViewHolder) view.getTag();
            }
            holder.imgIcon.setImageResource(item.getIconId());
            holder.txtTitle.setText(item.getLabelName());

            if (item.getLabelCount() > 0) {
                holder.txtEdge.setVisibility(View.VISIBLE);
                holder.txtEdge.setText(String.valueOf(item.getLabelCount()));
            } else {
                holder.txtEdge.setVisibility(View.GONE);
            }
            return view_;
        }

        class ViewHolder {
            @BindView(R.id.txtEdge)
            TextView txtEdge;
            @BindView(R.id.imgIcon)
            ImageView imgIcon;
            @BindView(R.id.txtTitle)
            TextView txtTitle;

            ViewHolder(View view) {
                ButterKnife.bind(this, view);
            }
        }
    }

}


