package example.fragment;

import android.graphics.drawable.Drawable;
import android.os.Bundle;
import android.support.v4.app.Fragment;
import android.support.v4.app.FragmentManager;
import android.support.v4.app.FragmentPagerAdapter;
import android.support.v4.content.ContextCompat;
import android.support.v4.view.ViewPager;

import com.qmuiteam.qmui.widget.QMUITabSegment;

import java.util.ArrayList;
import java.util.List;

import butterknife.BindView;
import xyz.wbsite.base.BaseSPAFragment;
import xyz.wbsite.wbui.R;

public class MainFragment extends BaseSPAFragment {

    @BindView(R.id.pager)
    ViewPager pager;
    @BindView(R.id.tabs)
    QMUITabSegment tabs;

    private List<Fragment> fragments = new ArrayList<>();

    @Override
    protected int getFragmnetLayout() {
        return R.layout.fragment_main;
    }

    @Override
    protected void onViewInit() {
        initTabs();
        initPagers();
    }

    @Override
    protected void onDataSave(Bundle data) {

    }

    @Override
    protected void onDataInit(Bundle data) {

    }

    private void initTabs() {
        QMUITabSegment.Tab function = new QMUITabSegment.Tab(
                getDrawable(R.drawable.icon_tabbar_home),
                getDrawable(R.drawable.icon_tabbar_home_select),
                "主页", false, false);
        QMUITabSegment.Tab function1 = new QMUITabSegment.Tab(
                getDrawable(R.drawable.icon_tabbar_function),
                getDrawable(R.drawable.icon_tabbar_function_select),
                "功能", false, false);
        QMUITabSegment.Tab function2 = new QMUITabSegment.Tab(
                getDrawable(R.drawable.icon_tabbar_about),
                getDrawable(R.drawable.icon_tabbar_about_select),
                "关于", false, false);
        tabs.addTab(function)
                .addTab(function1)
                .addTab(function2);
        tabs.setDefaultSelectedColor(getResources().getColor(R.color.colorPrimary));
    }

    private Drawable getDrawable(int r) {
        Drawable drawable = ContextCompat.getDrawable(getContext(), r);
        drawable.setBounds(0, 0, 50, 50);
        return drawable;
    }

    private void initPagers() {
        fragments.add(new HomeFragment());
        fragments.add(new FunFragment());
        fragments.add(new WebViewFragment());

        pager.setAdapter(new BaseFragmentPagerAdapter(getActivity().getSupportFragmentManager()));
        tabs.setupWithViewPager(pager, false);
        pager.setCurrentItem(1);
    }

    public boolean isFunFragment() {
        if (pager.getCurrentItem() == 1) {
            return true;
        }
        return false;
    }

    public void setFunFragment() {
        tabs.selectTab(1);
    }

    @Override
    protected boolean canDragBack() {
        return false;
    }

    private class BaseFragmentPagerAdapter extends FragmentPagerAdapter {

        public BaseFragmentPagerAdapter(FragmentManager fm) {
            super(fm);
        }

        @Override
        public Fragment getItem(int position) {
            return fragments.get(position);
        }

        @Override
        public int getCount() {
            return fragments.size();
        }
    }
}
