package example.fragment.functions.dialog;

import android.os.Bundle;
import android.view.View;

import com.qmuiteam.qmui.widget.QMUITopBarLayout;
import com.qmuiteam.qmui.widget.grouplist.QMUICommonListItemView;
import com.qmuiteam.qmui.widget.grouplist.QMUIGroupListView;

import butterknife.BindView;
import xyz.wbsite.base.BaseSPAFragment;
import xyz.wbsite.util.DialogUtil;
import xyz.wbsite.util.Toaster;
import xyz.wbsite.wbui.R;

public class DialogMenuFragment extends BaseSPAFragment implements View.OnClickListener {

    @BindView(R.id.topBar)
    QMUITopBarLayout topBar;
    @BindView(R.id.groupListView)
    QMUIGroupListView groupListView;

    @Override
    protected int getFragmnetLayout() {
        return R.layout.fragment_menu;
    }

    @Override
    protected void onViewInit() {
        topBar.setTitle("对话框");
        topBar.addLeftBackImageButton().setOnClickListener(new View.OnClickListener() {
            @Override
            public void onClick(View view) {
                popBackStack();
            }
        });
        initGroupListView();
    }

    @Override
    protected void onDataSave(Bundle data) {

    }

    @Override
    protected void onDataInit(Bundle data) {

    }

    private void initGroupListView() {
        QMUICommonListItemView itemWithChevron1 = groupListView.createItemView("普通消息");
        itemWithChevron1.setAccessoryType(QMUICommonListItemView.ACCESSORY_TYPE_CHEVRON);
        itemWithChevron1.setTag(1);

        QMUICommonListItemView itemWithChevron2 = groupListView.createItemView("普通消息(带回调)");
        itemWithChevron2.setAccessoryType(QMUICommonListItemView.ACCESSORY_TYPE_CHEVRON);
        itemWithChevron2.setTag(2);

        QMUICommonListItemView itemWithChevron3 = groupListView.createItemView("带强调Checkbox");
        itemWithChevron3.setAccessoryType(QMUICommonListItemView.ACCESSORY_TYPE_CHEVRON);
        itemWithChevron3.setTag(3);

        QMUICommonListItemView itemWithChevron4 = groupListView.createItemView("菜单选项");
        itemWithChevron4.setAccessoryType(QMUICommonListItemView.ACCESSORY_TYPE_CHEVRON);
        itemWithChevron4.setTag(4);

        QMUICommonListItemView itemWithChevron5 = groupListView.createItemView("多选菜单");
        itemWithChevron5.setAccessoryType(QMUICommonListItemView.ACCESSORY_TYPE_CHEVRON);
        itemWithChevron5.setTag(5);

        QMUIGroupListView.newSection(getContext())
                .addItemView(itemWithChevron1, this)
                .addItemView(itemWithChevron2, this)
                .addItemView(itemWithChevron3, this)
                .addItemView(itemWithChevron4, this)
                .addItemView(itemWithChevron5, this)
                .addTo(groupListView);
    }

    @Override
    public void onClick(View view) {
        if (view instanceof QMUICommonListItemView) {
            int tag = (int) view.getTag();

            switch (tag) {
                case 1:
                    DialogUtil.showMessage(getContext(), "提示", "标题");
                    break;
                case 2:
                    DialogUtil.showMessage(getContext(), "提示", "标题", new DialogUtil.MessageListener() {
                        @Override
                        public void onCallback(boolean positive) {
                            Toaster.showToast("已确认");
                        }
                    });
                    break;
                case 3:
                    DialogUtil.showCheckboxMessage(getContext(), "退出后是否删除账号信息?", "删除账号信息", new DialogUtil.MessageListener() {
                        @Override
                        public void onCallback(boolean positive) {
                            Toaster.showToast("已确认");
                        }
                    });
                    break;
                case 4:
                    DialogUtil.showOption(getContext(), new String[]{"选项1", "选项2"}, new DialogUtil.OptionListener() {
                        @Override
                        public void onCallback(int selected) {
                            Toaster.showToast("选择了" + selected);
                        }
                    });
                    break;
                case 5:
                    DialogUtil.showMultiOption(getContext(), new String[]{"选项1", "选项2"}, new int[]{0}, new DialogUtil.MultiOptionListener() {
                        @Override
                        public void onCallback(int[] selected) {
                            Toaster.showToast("选择了" + selected);
                        }
                    });
                    break;
            }
        }
    }
}