package example.fragment.functions.file;

import android.app.Activity;
import android.content.Intent;
import android.os.Bundle;
import android.view.View;

import com.qmuiteam.qmui.widget.QMUITopBarLayout;
import com.qmuiteam.qmui.widget.grouplist.QMUICommonListItemView;
import com.qmuiteam.qmui.widget.grouplist.QMUIGroupListView;

import butterknife.BindView;
import xyz.wbsite.activity.FilePickerActivity;
import xyz.wbsite.activity.TakePhotoActivity;
import xyz.wbsite.base.BaseSPAFragment;
import xyz.wbsite.base.IActivityResult;
import xyz.wbsite.util.Toaster;
import xyz.wbsite.util.UriUtil;
import xyz.wbsite.wbui.R;

public class FileMenuFragment extends BaseSPAFragment implements View.OnClickListener {

    @BindView(R.id.topBar)
    QMUITopBarLayout topBar;
    @BindView(R.id.groupListView)
    QMUIGroupListView groupListView;

    @Override
    protected int getFragmnetLayout() {
        return R.layout.fragment_menu;
    }

    @Override
    protected void onViewInit() {
        topBar.setTitle("文件选择");
        topBar.addLeftBackImageButton().setOnClickListener(new View.OnClickListener() {
            @Override
            public void onClick(View view) {
                popBackStack();
            }
        });
        initGroupListView();
    }

    @Override
    protected void onDataSave(Bundle data) {

    }

    @Override
    protected void onDataInit(Bundle data) {

    }

    private void initGroupListView() {
        QMUICommonListItemView itemWithChevron1 = groupListView.createItemView("文件选择");
        itemWithChevron1.setAccessoryType(QMUICommonListItemView.ACCESSORY_TYPE_CHEVRON);
        itemWithChevron1.setTag(1);

        QMUICommonListItemView itemWithChevron2 = groupListView.createItemView("相机拍照");
        itemWithChevron2.setAccessoryType(QMUICommonListItemView.ACCESSORY_TYPE_CHEVRON);
        itemWithChevron2.setTag(2);

        QMUICommonListItemView itemWithChevron3 = groupListView.createItemView("相册选择");
        itemWithChevron3.setAccessoryType(QMUICommonListItemView.ACCESSORY_TYPE_CHEVRON);
        itemWithChevron3.setTag(3);

        QMUIGroupListView.newSection(getContext())
                .addItemView(itemWithChevron1, this)
                .addItemView(itemWithChevron2, this)
                .addItemView(itemWithChevron3, this)
                .addTo(groupListView);
    }

    @Override
    public void onClick(View view) {
        if (view instanceof QMUICommonListItemView) {
            int tag = (int) view.getTag();

            switch (tag) {
                case 1: {

                    Intent intent = new Intent(getActivity(), FilePickerActivity.class);
                    startForResult(intent, new IActivityResult() {
                        @Override
                        public void onResult(int resultCode, Intent data) {
                            if (resultCode == RESULT_OK) {
                                Toaster.showToast(UriUtil.getPath(getActivity(), data.getData()));
                            } else {
                                Toaster.showToast("选择已取消");
                            }
                        }
                    });
                }
                break;
                case 2: {
                    Intent intent = new Intent(getActivity(), TakePhotoActivity.class);
                    intent.putExtra(TakePhotoActivity.POSITION_PARAM, TakePhotoActivity.POSITION_CAPTURE);
                    startForResult(intent, new IActivityResult() {
                        @Override
                        public void onResult(int resultCode, Intent data) {
                            if (resultCode == Activity.RESULT_OK) {
                                Toaster.showToast(UriUtil.getPath(getActivity(), data.getData()));
                            }
                        }
                    });
                }
                break;
                case 3: {
                    Intent intent = new Intent(getActivity(), TakePhotoActivity.class);
                    intent.putExtra(TakePhotoActivity.POSITION_PARAM, TakePhotoActivity.POSITION_GALLERY);
                    startForResult(intent, new IActivityResult() {
                        @Override
                        public void onResult(int resultCode, Intent data) {
                            if (resultCode == Activity.RESULT_OK) {
                                Toaster.showToast(UriUtil.getPath(getActivity(), data.getData()));
                            }
                        }
                    });
                }
            }
        }
    }
}
