package example.fragment.functions.image;

import android.os.Bundle;
import android.view.View;

import com.qmuiteam.qmui.widget.QMUITopBarLayout;
import com.qmuiteam.qmui.widget.grouplist.QMUICommonListItemView;
import com.qmuiteam.qmui.widget.grouplist.QMUIGroupListView;

import butterknife.BindView;
import xyz.wbsite.base.BaseSPAFragment;
import xyz.wbsite.wbui.R;

public class ImageMenuFragment extends BaseSPAFragment implements View.OnClickListener {

    @BindView(R.id.topBar)
    QMUITopBarLayout topBar;
    @BindView(R.id.groupListView)
    QMUIGroupListView groupListView;

    @Override
    protected int getFragmnetLayout() {
        return R.layout.fragment_menu;
    }

    @Override
    protected void onViewInit() {
        topBar.setTitle("图片处理");
        topBar.addLeftBackImageButton().setOnClickListener(new View.OnClickListener() {
            @Override
            public void onClick(View view) {
                popBackStack();
            }
        });
        initGroupListView();
    }

    @Override
    protected void onDataSave(Bundle data) {

    }

    @Override
    protected void onDataInit(Bundle data) {

    }

    private void initGroupListView() {
        QMUICommonListItemView itemWithChevron1 = groupListView.createItemView("图片查看器");
        itemWithChevron1.setAccessoryType(QMUICommonListItemView.ACCESSORY_TYPE_CHEVRON);
        itemWithChevron1.setTag(1);

        QMUICommonListItemView itemWithChevron2 = groupListView.createItemView("图片效果");
        itemWithChevron2.setAccessoryType(QMUICommonListItemView.ACCESSORY_TYPE_CHEVRON);
        itemWithChevron2.setTag(2);

        QMUIGroupListView.newSection(getContext())
                .addItemView(itemWithChevron1, this)
                .addItemView(itemWithChevron2, this)
                .addTo(groupListView);
    }

    @Override
    public void onClick(View view) {
        if (view instanceof QMUICommonListItemView) {
            int tag = (int) view.getTag();

            switch (tag) {
                case 1:
                    startFragment(BaseSPAFragment.newInstance(ViewerFragment.class));
                    break;
                case 2:
                    startFragment(BaseSPAFragment.newInstance(ImageViewFragment.class));
                    break;
            }
        }
    }
}
