package example.fragment.functions.image;

import android.os.Bundle;
import android.view.View;
import android.widget.ImageView;

import com.bumptech.glide.Glide;
import com.bumptech.glide.load.MultiTransformation;
import com.bumptech.glide.request.RequestOptions;
import com.qmuiteam.qmui.widget.QMUITopBarLayout;

import butterknife.BindView;
import jp.wasabeef.glide.transformations.BlurTransformation;
import jp.wasabeef.glide.transformations.GrayscaleTransformation;
import jp.wasabeef.glide.transformations.RoundedCornersTransformation;
import xyz.wbsite.base.BaseSPAFragment;
import xyz.wbsite.wbui.R;

import static com.bumptech.glide.request.RequestOptions.bitmapTransform;

public class ImageViewFragment extends BaseSPAFragment {
    @BindView(R.id.topBar)
    QMUITopBarLayout topBar;
    @BindView(R.id.img1)
    ImageView img1;
    @BindView(R.id.img2)
    ImageView img2;
    @BindView(R.id.img3)
    ImageView img3;
    @BindView(R.id.img4)
    ImageView img4;
    @BindView(R.id.img5)
    ImageView img5;

    @Override
    protected int getFragmnetLayout() {
        return R.layout.fragment_image_imageview;
    }

    @Override
    protected void onViewInit() {
        topBar.setTitle("图片变换");
        topBar.addLeftBackImageButton().setOnClickListener(new View.OnClickListener() {
            @Override
            public void onClick(View v) {
                popBackStack();
            }
        });

        // 高斯模糊
        Glide.with(this).load(R.drawable.demo_img)
                .apply(bitmapTransform(new BlurTransformation(10, 3)))
                .into(img1);

        // 黑白
        Glide.with(this).load(R.drawable.demo_img)
                .apply(bitmapTransform(new GrayscaleTransformation()))
                .into(img2);

        // 圆角
        Glide.with(this).load(R.drawable.demo_img)
                .apply(bitmapTransform(new RoundedCornersTransformation(100, 0)))
                .into(img3);

        // 圆型
        Glide.with(this).load(R.drawable.demo_img)
                .apply(RequestOptions.circleCropTransform())
                .into(img4);

        // 组合效果
        MultiTransformation multi = new MultiTransformation(
                new BlurTransformation(10),
                new RoundedCornersTransformation(100, 0, RoundedCornersTransformation.CornerType.ALL));
        Glide.with(this).load(R.drawable.demo_img)
                .apply(bitmapTransform(multi))
                .into(img5);
    }

    @Override
    protected void onDataSave(Bundle data) {

    }

    @Override
    protected void onDataInit(Bundle data) {

    }
}
