package example.fragment.functions.layout;

import android.os.Bundle;
import android.view.View;

import com.qmuiteam.qmui.widget.QMUITopBarLayout;
import com.qmuiteam.qmui.widget.grouplist.QMUICommonListItemView;
import com.qmuiteam.qmui.widget.grouplist.QMUIGroupListView;

import butterknife.BindView;
import xyz.wbsite.base.BaseSPAFragment;
import xyz.wbsite.wbui.R;

public class LayoutMenuFragment extends BaseSPAFragment implements View.OnClickListener {

    @BindView(R.id.topBar)
    QMUITopBarLayout topBar;
    @BindView(R.id.groupListView)
    QMUIGroupListView groupListView;

    @Override
    protected int getFragmnetLayout() {
        return R.layout.fragment_menu;
    }

    @Override
    protected void onViewInit() {
        topBar.setTitle("布局类组件");
        topBar.addLeftBackImageButton().setOnClickListener(new View.OnClickListener() {
            @Override
            public void onClick(View view) {
                popBackStack();
            }
        });
        initGroupListView();
    }

    @Override
    protected void onDataSave(Bundle data) {

    }

    @Override
    protected void onDataInit(Bundle data) {

    }

    private void initGroupListView() {
        QMUICommonListItemView itemWithChevron1 = groupListView.createItemView("固定长宽比布局");
        itemWithChevron1.setAccessoryType(QMUICommonListItemView.ACCESSORY_TYPE_CHEVRON);
        itemWithChevron1.setTag(1);

        QMUICommonListItemView itemWithChevron2 = groupListView.createItemView("下拉刷新");
        itemWithChevron2.setAccessoryType(QMUICommonListItemView.ACCESSORY_TYPE_CHEVRON);
        itemWithChevron2.setTag(2);

        QMUICommonListItemView itemWithChevron3 = groupListView.createItemView("上拉加载");
        itemWithChevron3.setAccessoryType(QMUICommonListItemView.ACCESSORY_TYPE_CHEVRON);
        itemWithChevron3.setTag(3);

        QMUICommonListItemView itemWithChevron4 = groupListView.createItemView("下拉和上拉同时存在a");
        itemWithChevron4.setAccessoryType(QMUICommonListItemView.ACCESSORY_TYPE_CHEVRON);
        itemWithChevron4.setTag(4);

        QMUIGroupListView.newSection(getContext())
                .addItemView(itemWithChevron1, this)
                .addItemView(itemWithChevron2, this)
                .addItemView(itemWithChevron3, this)
                .addItemView(itemWithChevron4, this)
                .addTo(groupListView);
    }

    @Override
    public void onClick(View view) {
        if (view instanceof QMUICommonListItemView) {
            int tag = (int) view.getTag();

            switch (tag) {
                case 1:
                    startFragment(BaseSPAFragment.newInstance(ScaleLayoutFragment.class));
                    break;
                case 2:
                    startFragment(BaseSPAFragment.newInstance(PaternalLayoutPullFragment.class));
                    break;
                case 3:
                    startFragment(BaseSPAFragment.newInstance(PaternalLayoutPushFragment.class));
                    break;
                case 4:
                    startFragment(BaseSPAFragment.newInstance(PaternalLayoutPullPushFragment.class));
                    break;
            }
        }
    }
}