package example.fragment.functions.layout;

import android.os.Bundle;
import android.view.Gravity;
import android.view.View;
import android.widget.LinearLayout;

import com.qmuiteam.qmui.widget.QMUITopBarLayout;

import butterknife.BindView;
import xyz.wbsite.base.BaseSPAFragment;
import xyz.wbsite.wbui.R;
import xyz.wbsite.wbui.layout.WBUIPaternalLayout;
import xyz.wbsite.wbui.other.WBUILoadingProgressBar;

public class PaternalLayoutPullPushFragment extends BaseSPAFragment {

    @BindView(R.id.topBar)
    QMUITopBarLayout topBar;
    @BindView(R.id.paternalLayout)
    WBUIPaternalLayout paternalLayout;

    @Override
    protected int getFragmnetLayout() {
        return R.layout.fragment_layout_push;
    }

    @Override
    protected void onViewInit() {
        topBar.setTitle("下拉和上拉同时存在");
        topBar.addLeftBackImageButton().setOnClickListener(new View.OnClickListener() {
            @Override
            public void onClick(View view) {
                popBackStack();
            }
        });
        paternalLayout.setPullViewBuilder(new WBUIPaternalLayout.IPullViewBuilder() {
            WBUILoadingProgressBar progressBar;

            @Override
            public View createView() {
                LinearLayout linearLayout = new LinearLayout(getContext());
                linearLayout.setGravity(Gravity.CENTER);
                progressBar = new WBUILoadingProgressBar(getContext());
                linearLayout.addView(progressBar);
                return linearLayout;
            }

            @Override
            public void onChange(View view, int currentHeight, int pullHeight, boolean isNearHeight) {
                if (currentHeight > pullHeight) {
                    progressBar.setProgress(1);
                } else {
                    progressBar.setProgress(currentHeight * 1.0f / pullHeight);
                }
            }

            @Override
            public void onAction(View view, int pullHeight, WBUIPaternalLayout layout) {
                progressBar.startAnimation();
                handler.postDelayed(new Runnable() {
                    @Override
                    public void run() {
                        paternalLayout.finish();
                    }
                }, 1000);
            }

            @Override
            public void onFinish(View view) {
                progressBar.stopAnimation();
                progressBar.setProgress(0);
            }
        });
        paternalLayout.setPushViewBuilder(new WBUIPaternalLayout.IPushViewBuilder() {
            WBUILoadingProgressBar progressBar;

            @Override
            public View createView() {
                LinearLayout linearLayout = new LinearLayout(getContext());
                linearLayout.setGravity(Gravity.CENTER);
                progressBar = new WBUILoadingProgressBar(getContext());
                linearLayout.addView(progressBar);
                return linearLayout;
            }

            @Override
            public void onChange(View view, int currentHeight, int pullHeight, boolean isNearHeight) {
                if (currentHeight > pullHeight) {
                    progressBar.setProgress(1);
                } else {
                    progressBar.setProgress(currentHeight * 1.0f / pullHeight);
                }
            }

            @Override
            public void onAction(View view, int pullHeight, WBUIPaternalLayout layout) {
                progressBar.startAnimation();
                handler.postDelayed(new Runnable() {
                    @Override
                    public void run() {
                        paternalLayout.finish();
                    }
                }, 1000);
            }

            @Override
            public void onFinish(View view) {
                progressBar.stopAnimation();
                progressBar.setProgress(0);
            }
        });
    }

    @Override
    protected void onDataSave(Bundle data) {

    }

    @Override
    protected void onDataInit(Bundle data) {

    }

    @Override
    protected boolean canDragBack() {
        return true;
    }
}
