package example.fragment.functions.util;

import android.net.Uri;
import android.os.Bundle;
import android.view.View;

import com.qmuiteam.qmui.widget.QMUITopBarLayout;

import java.io.File;
import java.text.SimpleDateFormat;
import java.util.Date;

import butterknife.BindView;
import butterknife.OnClick;
import xyz.wbsite.base.BaseSPAFragment;
import xyz.wbsite.base.Consant;
import xyz.wbsite.util.SPUtil;
import xyz.wbsite.util.StorageUtil;
import xyz.wbsite.util.Toaster;
import xyz.wbsite.util.UriUtil;
import xyz.wbsite.wbui.R;

public class UtilMenuFragment extends BaseSPAFragment {

    @BindView(R.id.topBar)
    QMUITopBarLayout topBar;

    @Override
    protected int getFragmnetLayout() {
        return R.layout.fragment_util_menu;
    }

    @Override
    protected void onViewInit() {
        topBar.setTitle("工具类");
        topBar.addLeftBackImageButton().setOnClickListener(new View.OnClickListener() {
            @Override
            public void onClick(View view) {
                popBackStack();
            }
        });
    }

    @Override
    protected void onDataSave(Bundle data) {

    }

    @Override
    protected void onDataInit(Bundle data) {

    }

    @OnClick({
            R.id.btnCacheDir,
            R.id.btnFilesDir,
            R.id.btnLocalDir,
            R.id.btnUriUtil,
            R.id.btnSPUtil1,
            R.id.btnSPUtil2,
    })
    void onAction(View view) {
        String tag = (String) view.getTag();
        switch (tag) {
            case "btnCacheDir":
                Toaster.showToast(StorageUtil.getCacheDir(getContext()).getAbsolutePath());
                break;
            case "btnFilesDir":
                Toaster.showToast(StorageUtil.getFilesDir(getContext()).getAbsolutePath());
                break;
            case "btnLocalDir":
                Toaster.showToast(StorageUtil.getLocalDir(getContext(), Consant.DIR).getAbsolutePath());
                break;
            case "btnUriUtil":
                Uri uri = Uri.fromFile(StorageUtil.getLocalDir(getContext(), Consant.DIR));
                String path = UriUtil.getPath(getContext(), uri);
                Toaster.showToast(path);
                break;
            case "btnSPUtil1":
                SPUtil.putString("btnSPUtil1", new SimpleDateFormat("yyyy-MM-dd HH:mm:ss").format(new Date()));
                Toaster.showToast("put成功");
                break;
            case "btnSPUtil2":
                String btnSPUtil1 = SPUtil.getString("btnSPUtil1");
                Toaster.showToast("get成功:" + btnSPUtil1);
                break;
        }
    }
}