package example.fragment.functions.widget;

import android.graphics.Bitmap;
import android.os.Bundle;
import android.view.View;
import android.widget.Button;

import com.qmuiteam.qmui.widget.QMUITopBarLayout;

import butterknife.BindView;
import xyz.wbsite.base.BaseSPAFragment;
import xyz.wbsite.util.Toaster;
import xyz.wbsite.wbui.R;
import xyz.wbsite.wbui.other.WBUISignatureView;

public class SignatureViewFragment extends BaseSPAFragment {

    @BindView(R.id.topBar)
    QMUITopBarLayout topBar;
    @BindView(R.id.signView)
    WBUISignatureView signView;
    @BindView(R.id.btnSave)
    Button btnSave;
    @BindView(R.id.btnClear)
    Button btnClear;

    @Override
    protected int getFragmnetLayout() {
        return R.layout.fragment_widget_signature;
    }

    @Override
    protected void onViewInit() {
        topBar.setTitle("签名器");
        topBar.addLeftBackImageButton().setOnClickListener(new View.OnClickListener() {
            @Override
            public void onClick(View view) {
                popBackStack();
            }
        });

        btnSave.setOnClickListener(new View.OnClickListener() {
            @Override
            public void onClick(View v) {
                Bitmap bitMap = signView.getBitMap();
                if (bitMap != null) {
                    Toaster.showToast("获取到Bitmap");
                } else {
                    Toaster.showToast("获取失败");
                }
            }
        });
        btnClear.setOnClickListener(new View.OnClickListener() {
            @Override
            public void onClick(View v) {
                signView.clear();
                Toaster.showToast("清除成功");
            }
        });
    }

    @Override
    protected void onDataSave(Bundle data) {

    }

    @Override
    protected void onDataInit(Bundle data) {

    }

}