package example.fragment.functions.widget;

import android.os.Bundle;
import android.view.View;

import com.qmuiteam.qmui.widget.QMUITopBarLayout;
import com.qmuiteam.qmui.widget.grouplist.QMUICommonListItemView;
import com.qmuiteam.qmui.widget.grouplist.QMUIGroupListView;

import butterknife.BindView;
import xyz.wbsite.base.BaseSPAFragment;
import xyz.wbsite.wbui.R;

public class WidgetMenuFragment extends BaseSPAFragment implements View.OnClickListener {

    @BindView(R.id.topBar)
    QMUITopBarLayout topBar;
    @BindView(R.id.groupListView)
    QMUIGroupListView groupListView;

    @Override
    protected int getFragmnetLayout() {
        return R.layout.fragment_menu;
    }

    @Override
    protected void onViewInit() {
        topBar.setTitle("UI组件");
        topBar.addLeftBackImageButton().setOnClickListener(new View.OnClickListener() {
            @Override
            public void onClick(View view) {
                popBackStack();
            }
        });
        initGroupListView();
    }

    @Override
    protected void onDataSave(Bundle data) {

    }

    @Override
    protected void onDataInit(Bundle data) {

    }

    private void initGroupListView() {
        QMUICommonListItemView itemWithChevron1 = groupListView.createItemView("加载条");
        itemWithChevron1.setAccessoryType(QMUICommonListItemView.ACCESSORY_TYPE_CHEVRON);
        itemWithChevron1.setTag(1);

        QMUICommonListItemView itemWithChevron2 = groupListView.createItemView("签名器");
        itemWithChevron2.setAccessoryType(QMUICommonListItemView.ACCESSORY_TYPE_CHEVRON);
        itemWithChevron2.setTag(2);

        QMUICommonListItemView itemWithChevron3 = groupListView.createItemView("文字均分对齐");
        itemWithChevron3.setAccessoryType(QMUICommonListItemView.ACCESSORY_TYPE_CHEVRON);
        itemWithChevron3.setTag(3);

        QMUICommonListItemView itemWithChevron4 = groupListView.createItemView("按钮");
        itemWithChevron4.setAccessoryType(QMUICommonListItemView.ACCESSORY_TYPE_CHEVRON);
        itemWithChevron4.setTag(4);

        QMUICommonListItemView itemWithChevron5 = groupListView.createItemView("其他");
        itemWithChevron5.setAccessoryType(QMUICommonListItemView.ACCESSORY_TYPE_CHEVRON);
        itemWithChevron5.setTag(10);

        QMUIGroupListView.newSection(getContext())
                .addItemView(itemWithChevron1, this)
                .addItemView(itemWithChevron2, this)
                .addItemView(itemWithChevron3, this)
                .addItemView(itemWithChevron4, this)
                .addItemView(itemWithChevron5, this)
                .addTo(groupListView);
    }

    @Override
    public void onClick(View view) {
        if (view instanceof QMUICommonListItemView) {
            int tag = (int) view.getTag();

            switch (tag) {
                case 1:
                    startFragment(BaseSPAFragment.newInstance(LoadingBarFragment.class));
                    break;
                case 2:
                    startFragment(BaseSPAFragment.newInstance(SignatureViewFragment.class));
                    break;
                case 3:
                    startFragment(BaseSPAFragment.newInstance(AlignTextViewFragment.class));
                    break;
                case 4:
                    startFragment(BaseSPAFragment.newInstance(ButtonViewFragment.class));
                    break;
                case 10:
                    startFragment(BaseSPAFragment.newInstance(OtherViewFragment.class));
                    break;
            }
        }
    }
}