package xyz.wbsite.service;


import android.app.Service;
import android.content.Context;
import android.content.Intent;
import android.os.Handler;
import android.os.IBinder;

public class RestartService extends Service {

    private Handler handler = new Handler();

    /**
     * 应用关闭重启时间
     */
    private static long stopDelayed = 1000;

    /**
     * 重启整个APP
     *
     * @param context
     * @param Delayed 延迟多少毫秒
     */
    public static void restartAPP(Context context, long Delayed) {

        // 开启服务，用来重启
        Intent intent = new Intent(context, RestartService.class);
        intent.putExtra("Delayed", Delayed);
        context.startService(intent);

        // 杀死进程
        android.os.Process.killProcess(android.os.Process.myPid());
    }


    @Override
    public int onStartCommand(final Intent intent, int flags, int startId) {
        handler.postDelayed(new Runnable() {
            @Override
            public void run() {
                Intent LaunchIntent = getPackageManager().getLaunchIntentForPackage(getPackageName());
                startActivity(LaunchIntent);
                RestartService.this.stopSelf();
            }
        }, stopDelayed);
        return super.onStartCommand(intent, flags, startId);
    }

    @Override
    public IBinder onBind(Intent intent) {
        return null;
    }
}