package xyz.wbsite.util;

import android.app.NotificationChannel;
import android.app.NotificationManager;
import android.app.Service;
import android.content.Context;
import android.graphics.Color;
import android.os.Build;
import android.os.Vibrator;
import android.support.v4.app.NotificationCompat;

import xyz.wbsite.wbui.R;

public class NoticesUtil {
    private static String CALENDAR_ID = "channel";

    public static void notices(Context context, String title, String content) {
        NotificationManager notificationManager = (NotificationManager) context.getSystemService(Service.NOTIFICATION_SERVICE);

        if (Build.VERSION.SDK_INT >= Build.VERSION_CODES.O) {// 26以上需要创建通知渠道，否则无法显示通知
            NotificationChannel notificationChannel = notificationManager.getNotificationChannel(CALENDAR_ID);
            if (notificationChannel == null) {
                notificationChannel = new NotificationChannel(CALENDAR_ID, "消息",
                        NotificationManager.IMPORTANCE_DEFAULT);
                // 设置渠道描述
                notificationChannel.setDescription("消息组");
                // 是否绕过请勿打扰模式
                notificationChannel.canBypassDnd();
                // 设置绕过请勿打扰模式
                notificationChannel.setBypassDnd(true);
                // 桌面Launcher的消息角标
                notificationChannel.canShowBadge();
                // 设置显示桌面Launcher的消息角标
                notificationChannel.setShowBadge(true);
                // 设置通知出现时声音，默认通知是有声音的
                notificationChannel.setSound(null, null);
                // 设置通知出现时的闪灯（如果 android 设备支持的话）
                notificationChannel.enableLights(true);
                notificationChannel.setLightColor(Color.RED);
                //是否会有灯光
                notificationChannel.shouldShowLights();
                // 设置通知出现时的震动（如果 android 设备支持的话）
                notificationChannel.enableVibration(true);
                notificationChannel.setVibrationPattern(new long[]{0, 300, 200, 500});
                notificationManager.createNotificationChannel(notificationChannel);
            }
        }

        NotificationCompat.Builder builder = new NotificationCompat.Builder(context, CALENDAR_ID)
                //设置小图标
                .setSmallIcon(R.mipmap.ic_launcher)
                //设置通知标题
                .setContentTitle(title)
                //设置通知内容
                .setContentText(content)
                .setAutoCancel(true);
        notificationManager.notify(1, builder.build());
    }

    /**
     * 轻微震感，建议用于按键反馈
     *
     * @param content
     */
    public static void vibrateTap(Context content) {
        Vibrator mVibrator = (Vibrator) content.getSystemService(Service.VIBRATOR_SERVICE);
        mVibrator.vibrate(new long[]{0, 20}, -1);
    }

    /**
     * 强烈震感,建议用于事件反馈
     *
     * @param content
     */
    public static void vibrateStrong(Context content) {
        Vibrator mVibrator = (Vibrator) content.getSystemService(Service.VIBRATOR_SERVICE);
        mVibrator.vibrate(new long[]{0, 300}, -1);
    }

    /**
     * 连续震感,建议用于消息提醒等
     *
     * @param content
     */
    public static void vibrateSeries(Context content) {
        Vibrator mVibrator = (Vibrator) content.getSystemService(Service.VIBRATOR_SERVICE);
        mVibrator.vibrate(new long[]{0, 300, 200, 500}, -1);
    }

}
