package xyz.wbsite.util;

import java.util.regex.Matcher;
import java.util.regex.Pattern;

/**
 * 常用验证工具类
 */
public class ValidateUtil {

    /**
     * 是否是有效的身份证号码
     *
     * @param id
     * @return
     */
    public static boolean isIdcard(String id) {

        if (id == null || id.length() != 18) {
            return false;
        }
        char[] c = id.toCharArray();
        int sum = 0;
        int[] w = {7, 9, 10, 5, 8, 4, 2, 1, 6,
                3, 7, 9, 10, 5, 8, 4, 2};
        for (int i = 0; i < w.length; i++) {
            sum += (c[i] - '0') * w[i];
        }
        char[] verifyCode = "10X98765432".toCharArray();
        char ch = verifyCode[sum % 11];
        return c[17] == ch;
    }

    /**
     * 手机号验证
     *
     * @param str
     * @return 验证通过返回true
     */
    public static boolean isMobile(final String str) {
        Pattern p = null;
        Matcher m = null;
        boolean b = false;
        p = Pattern.compile("^[1][3,4,5,7,8][0-9]{9}$"); // 验证手机号
        m = p.matcher(str);
        b = m.matches();
        return b;
    }

    /**
     * 电话号码验证
     *
     * @param str
     * @return 验证通过返回true
     */
    public static boolean isPhone(final String str) {
        Pattern p1 = null, p2 = null;
        Matcher m = null;
        boolean b = false;
        p1 = Pattern.compile("^[0][1-9]{2,3}-[0-9]{5,10}$");  // 验证带区号的
        p2 = Pattern.compile("^[1-9]{1}[0-9]{5,8}$");         // 验证没有区号的
        if (str.length() > 9) {
            m = p1.matcher(str);
            b = m.matches();
        } else {
            m = p2.matcher(str);
            b = m.matches();
        }
        return b;
    }
}