package xyz.wbsite.wbui.widget.button;

import android.content.Context;
import android.graphics.Canvas;
import android.graphics.Color;
import android.graphics.Paint;
import android.graphics.drawable.Drawable;
import android.util.AttributeSet;
import android.util.DisplayMetrics;
import android.util.TypedValue;
import android.view.ViewParent;

import com.qmuiteam.qmui.alpha.QMUIAlphaButton;
import com.qmuiteam.qmui.util.QMUIResHelper;

import xyz.wbsite.wbui.widget.button.WBUIButton;

/**
 * 带有右箭头的Button
 */
public class WBUIArrowButton extends QMUIAlphaButton {


    private Paint mPaint;

    public WBUIArrowButton(Context context) {
        super(context);
        init(null, 0);
    }

    public WBUIArrowButton(Context context, AttributeSet attrs) {
        super(context, attrs);
        init(attrs, 0);
    }

    public WBUIArrowButton(Context context, AttributeSet attrs, int defStyle) {
        super(context, attrs, defStyle);
        init(attrs, defStyle);
    }

    private void init(AttributeSet attrs, int defStyle) {
        DisplayMetrics metrics = getResources().getDisplayMetrics();
        Drawable attrDrawable = QMUIResHelper.getAttrDrawable(getContext(), com.qmuiteam.qmui.R.attr.qmui_common_list_item_chevron);
        attrDrawable.setBounds(0, 0,
                (int) TypedValue.applyDimension(TypedValue.COMPLEX_UNIT_DIP, 8, metrics),
                (int) TypedValue.applyDimension(TypedValue.COMPLEX_UNIT_DIP, 12, metrics));
        mPaint = new Paint();
        mPaint.setStrokeWidth(1f);
        mPaint.setColor(Color.parseColor("#DDDDDD"));
        this.setCompoundDrawables(null, null, attrDrawable, null);
        this.setBackground(null);
    }

    @Override
    protected void onDraw(Canvas canvas) {
        super.onDraw(canvas);
        canvas.drawLine(0, getMeasuredHeight() - 1, getMeasuredWidth(), getMeasuredHeight() - 1, mPaint);
    }
}
