package xyz.wbsite.wbui.widget.form;

import android.content.Context;
import android.content.res.TypedArray;
import android.support.annotation.Nullable;
import android.util.AttributeSet;
import android.view.LayoutInflater;
import android.widget.LinearLayout;
import android.widget.TextView;

import xyz.wbsite.wbui.R;

public class FormSwitchView extends LinearLayout {

    protected String label;
    protected boolean required;
    protected boolean readOnly;

    protected TextView txtLabel;

    public FormSwitchView(Context context) {
        super(context);
    }

    public FormSwitchView(Context context, @Nullable AttributeSet attrs) {
        super(context, attrs);
        TypedArray a = context.obtainStyledAttributes(attrs, R.styleable.FormView);
        label = a.getString(R.styleable.FormView_label);
        required = a.getBoolean(R.styleable.FormView_required, false);
        readOnly = a.getBoolean(R.styleable.FormView_readOnly, false);
        a.recycle();
        init();
    }

    private void init() {
        setSaveEnabled(true);
        LayoutInflater.from(getContext()).inflate(R.layout.ui_form_switch_view, this);
        txtLabel = findViewById(R.id.txtLabel);
        txtLabel.setText(label);
    }

}
