package xyz.wbsite.wbui.widget.form;

import android.content.Context;
import android.content.res.TypedArray;
import android.support.annotation.Nullable;
import android.util.AttributeSet;
import android.view.View;

import cn.qqtheme.framework.picker.NumberPicker;
import xyz.wbsite.base.BaseSPAActivity;
import xyz.wbsite.wbui.R;

public class NUMBERFormInputView extends FormInputView {
    private NumberPicker picker;
    private int currentNumber;
    private int numberStart;
    private int numberEnd;

    public NUMBERFormInputView(Context context) {
        super(context);
    }

    public NUMBERFormInputView(Context context, @Nullable AttributeSet attrs) {
        super(context, attrs);
    }

    @Override
    protected void init(AttributeSet attrs) {
        super.init(attrs);
        // 获取自定义属性
        TypedArray a = getContext().obtainStyledAttributes(attrs, R.styleable.FormView);
        this.numberStart = a.getInt(R.styleable.FormView_numberStart, 0);
        this.numberEnd = a.getInt(R.styleable.FormView_numberEnd, 10);
        a.recycle();
        //初始化InputView
        edtInput.setEnabled(true);
        edtInput.setFocusable(false);
        edtInput.setKeyListener(null);
        edtInput.setHint("请选择");
        edtInput.setOnClickListener(new OnClickListener() {
            @Override
            public void onClick(View v) {
                onShowPicker();
            }
        });
    }

    private void onShowPicker() {
        //初始化日期选择器
        picker = new NumberPicker((BaseSPAActivity) getContext());
        picker.setRange(this.numberStart, this.numberEnd);
        picker.setSelectedItem(Integer.valueOf(currentNumber));
        picker.setOnNumberPickListener(new NumberPicker.OnNumberPickListener() {
            @Override
            public void onNumberPicked(int index, Number item) {
                currentNumber = item.intValue();
                onPrint();
            }
        });
        picker.show();
    }

    @Override
    public void onClear() {
        super.onClear();
        currentNumber = 0;
        picker = null;
    }

    private void onPrint() {
        edtInput.setText(String.valueOf(currentNumber));
    }
}
