package xyz.wbsite.wbui.widget.form;

import android.content.Context;
import android.support.annotation.Nullable;
import android.text.InputFilter;
import android.text.method.DigitsKeyListener;
import android.util.AttributeSet;

import xyz.wbsite.util.ValidateUtil;

public class SFZHFormInputView extends FormInputView {

    public SFZHFormInputView(Context context) {
        super(context);
    }

    public SFZHFormInputView(Context context, @Nullable AttributeSet attrs) {
        super(context, attrs);
    }

    @Override
    protected void init(AttributeSet attrs) {
        super.init(attrs);
        // 输入框字典
        edtInput.setKeyListener(DigitsKeyListener.getInstance("0123456789X"));
        // 输入长度
        edtInput.setFilters(new InputFilter[]{new InputFilter.LengthFilter(18)});
    }

    @Override
    public String validData() {
        String valid = super.validData();
        if (valid == null && !ValidateUtil.isIdcard(code)) {
            return "证件号码格式不正确!";
        }
        return valid;
    }
}
